import os
import stat
import pdb

def fullName(directory,name) :
	return directory+"//"+name
def isDir(name) :
	return stat.S_ISDIR(os.lstat(name).st_mode)
def isFile(name) :
	return stat.S_ISREG(os.lstat(name).st_mode)
def equalFileName(x,y):
	return str(x).lower()==str(y).lower()
	
def find(fileName,directory,compare=equalFileName) :
	result=[]
	lst=os.listdir(directory)
	for x in lst :
		name=fullName(directory,x)
		if isFile(name) and compare(x,fileName) :
			result.append(name)
			print name
		if isDir(name) :
			result.extend(find(fileName,name,compare))
	return result
	

class ListOfFiles :
	def __init__(self,ListOfExtensions=['cpp','hpp','h','py','idl'],ListOfExcludes=['.hg','Debug','debug','Release','release']) :
		self._extensions=ListOfExtensions
		self._excludes=ListOfExcludes
	def make(self,directory='.') :
		result=[]
		lst=os.listdir(directory)
		for x in lst :
			if self.excludes(x) :
				continue
			name=fullName(directory,x)
			if isDir(name) :
				result.extend(self.make(name))
			if isFile(name) and self.isCorrectExtension(name) :
				result.append(name)
		return result
	def excludes(self,name) :
		for x in self._excludes :
			if name==x :
				return True
		return False
	def isCorrectExtension(self,name) :
		if self._extensions==[] :
			return True
		for x in self._extensions :
			if name.endswith(x) :
				return True
		return False
		
#def fileAll(files=ListOfFiles().make(),fileName="aaa.txt") :
#the above does not work because it forces ListOfFiles().make() execution on load of module
def fileAll(files,fileName="aaa.txt") :
	out=open(fileName,"w")
	for x in files :
		out.write(x)
		out.write('\n')
	out.write('\n\n\n')
	for x in files :
		f=open(x,"r")
		s=f.read()
		f.close()
		out.write('*******************  '+x+'  *******************\n')
		out.write(s)
		out.write('\n\n')
	out.close()
	