import os
import os.path
import pdb

class DirectoryList :
	"""
		Creates list of files in the given directory.
		Non recursive.
		Subdirectories are not listed.
	"""
	def __init__(self,path) :
		self._dirList=[]
		s=str(path).strip()
		if( not s.endswith('\\') and not s.endswith('/') ) :
			s+='/'
		self._path=s
	def _callBack( self,arg,dirname,fnames ) :
		L=[]
		toRemove=[]
		for x in fnames :
			if os.path.isfile(dirname+x) :
				L.append(x)
			else :
				toRemove.append(x)
		for x in toRemove :
			fnames.remove(x)
		for x in L :
			self._dirList.append(x)
	def make(self) :
		os.path.walk(
			self._path,
			lambda arg,dirname,fnames : self._callBack(arg,dirname,fnames),
			None
		)
		return self._dirList
	def reset(self) :
		self.distList=[]
		
def Walk( root, recurse=0, pattern='*', return_folders=0 ):
	"""
	Walk( root, recurse=0, pattern='*', return_folders=0 )
	Walk through root directory and collect the list of files.
	"""
	import fnmatch, os, string
	
	# initialize
	result = []

	# must have at least root folder
	try:
		names = os.listdir(root)
	except os.error:
		return result

	# expand pattern
	pattern = pattern or '*'
	pat_list = string.splitfields( pattern , ';' )
	
	# check each file
	for name in names:
		fullname = os.path.normpath(os.path.join(root, name))

		# grab if it matches our pattern and entry type
		for pat in pat_list:
			if fnmatch.fnmatch(name, pat):
				if os.path.isfile(fullname) or (return_folders and os.path.isdir(fullname)):
					result.append(fullname)
				continue
				
		# recursively scan other folders, appending results
		if recurse:
			if os.path.isdir(fullname) and not os.path.islink(fullname):
				result = result + Walk( fullname, recurse, pattern, return_folders )
			
	return result

def removeExtensionFiles(root,ext) :
	L=Walk(root,recurse=1)
	exten='.'+ext
	for x in L :
		if os.path.isfile(x) :
			(name,ext)=os.path.splitext(x)
			if ext==exten :
				print x
				os.remove(x)
				
				