import ots.std as std
		
_OutDir=std.Stack()
_InDir=std.Stack()

def setOutputDir(d) :
	if( isinstance(d,str) ) :
		dd=FullFileName(d)
	elif( isinstance(d,FullFileName) ) :
		dd=d
	else :
		raise(Exception('Unexpected case in setOutDir'))
	_OutDir.push(dd)
def discardOutputDir() :
	_OutDir.pop()
def outputDir() :
	return _OutDir.peek()
def setInputDir(d) :
	if( isinstance(d,str) ) :
		dd=FullFileName(d)
	elif( isinstance(d,FullFileName) ) :
		dd=d
	else :
		raise(Exception('Unexpected case in setInDir'))
	_InDir.push(dd)
def discardInputDir() :
	_InDir.pop()
def inputDir() :
	return _InDir.peek()


	
def inputFileName(fileName,inputDir='') :
	if( isinstance(fileName,str) ) :
		fileName=ShortFileName(fileName)
	if( inputDir is None or inputDir=='' ) :
		d=_InDir.peek()
		if( d is None ) :
			return fileName
		return d+fileName
	if( isinstance(inputDir,str) ) :
		inputDir=FullFileName(inputDir)
	elif( isinstance(inputDir,FullFileName) ) :
		pass
	else :
		raise(Exception('Unexpected case in inputFileName'))
	return inputDir+fileName
def outputFileName(fileName,outputDir='') :
	if( isinstance(fileName,str) ) :
		fileName=ShortFileName(fileName)
	if( outputDir is None or outputDir=='' ) :
		d=_OutDir.peek()
		if( d is None ) :
			return fileName
		return d+fileName
	if( isinstance(outputDir,str) ) :
		outputDir=FullFileName(outputDir)
	elif( isinstance(outputDir,FullFileName) ) :
		pass
	else :
		raise(Exception('Unexpected case in outputFileName'))
	return outputDir+fileName
	
def fileToString( fileName, inputDir='' ) :
	f=open(str(inputFileName(fileName=fileName,inputDir=inputDir)),'r')
	s=f.read()
	f.close()
	return s
	
def stringToFile( fileName, text, outputDir='' ) :
	f=open(str(outputFileName(fileName=fileName,outputDir=outputDir)),"w")
	f.write(text)
	f.close()

def save(obj,fileName='__data__',saveDir='') :
	"Save an object using pickle. User defined objects have to be defined in module."
	import pickle
	if(fileName=='') :
		return
	f=open(str(outputFileName(fileName=fileName+'.pkl',outputDir=saveDir)),'w')
	try :
		pickle.dump(obj,f)
		f.close()
	except :
		f.close()
		raise
def getSaveFile(fileName='__data__',saveDir='') :
	"Get file name where 'save' would place output."
	if(fileName=='') :
		return
	return str(outputFileName(fileName=fileName+'.pkl',outputDir=saveDir))
def load(fileName='__data__',loadDir='') :
	"Load an object using pickle. User defined objects have to be defined in module."
	import pickle
	f=open(str(inputFileName(fileName=fileName+'.pkl',inputDir=loadDir)),'r')
	try :
		obj=pickle.load(f)
	except :
		f.close()
		raise
	f.close()
	return obj

def makeDir( name ) :
	if( isinstance(name,str) ) :
		name=FullFileName(name)
	elif( not isinstance(name,FullFileName) ) :
		raise(Exception('Unexpected argument type in makeDir'))
	if( not name._name[0][1]==':' ) :
		raise(Exception('The name argument of makeDir has to contain a full absolute path '))
	i=1
	s=name._name[0]
	while(i<len(name._name)) :
		s+='/'+name._name[i]
		if( not os.path.exists(s) ) :
			os.mkdir(s)
		i+=1
		