import pdb

	
def askBeforeDelete(name,directory) :
	print 'Delete '+name+' file(s) in the directory "'+directory+'"?'
	print '(y/n)<Enter>'
	y=True
	n=False
	return input()
	
	

class MakeFile :
	doDeleteFiles=True
	def __init__(self,
		outputName,outputDir,files,
		objDir='objs',
		version=None,runtime=None,output=None,
		askBeforeDelete=True,
		**kwargs
	) :
		import ots.make.options as opt
		if( version is None ) :
			version=opt.Version.Release
		if( runtime is None ) :
			runtime=opt.Runtime.Msvc9
		if( output is None ) :
			output=opt.Output.Dll
		self.version=version
		self.runtime=runtime
		self.output=output
		self.outputName=outputName
		self.outputDir=outputDir
		self.objDir=objDir
		self.files=files
		self.askBeforeDelete=askBeforeDelete
		od=str(objDir)
		if( od[1]==':' ) :
			self.objDir=objDir
		else :
			self.objDir=self.outputDir+objDir
		for k in kwargs :
			setattr(self,k,kwargs[k])
	def copyDependencies(self) :
		libs2=self.libs
		for x in self.libs :
			try :
				libs2.extend(x.depends())
			except AttributeError,ex :
				if( not str(ex).endswith("'depends'") ) :
					raise
		dlls=[]
		for x in libs2 :
			try :
				dlls.extend(x.dllPath(version=self.version,runtime=self.runtime,libs=self.libs))
			except AttributeError,ex:
				if( not str(ex).endswith("'dllPath'") ) :
					raise
		import ots.io as io
		for x in dlls :
			io.copy(x,self.outputDir)
	def build(self) :
		import os
		import ots.io as io
		makeDir=str(self.outputDir)
		if( not os.path.exists(makeDir) ) :
			os.makedirs(makeDir)
		objDir=str(self.objDir)
		if( not os.path.exists(objDir) ) :
			os.makedirs(objDir)
		else :
			if( MakeFile.doDeleteFiles ) :
				if( not self.askBeforeDelete or askBeforeDelete('obj',objDir) ) :
					cmd='del /f/s/q "'+objDir+'"\*.obj'
					os.system(cmd)
				goal=str(self.outputDir+self.outputName+('.'+self.output.idString()))
				if( not self.askBeforeDelete or askBeforeDelete(str(self.outputName+('.'+self.output.idString())),makeDir) ) :
					try :
						os.remove(goal)
					except :
						pass
		makeFile=str(self.objDir+'doIt.mak')
		if( not os.path.exists(makeFile) ) :
			self.make()
		import ots.make.options as opt
		vsvarsFile=objDir+io.separator+'callVsvars32.bat'
		nmakeFile=objDir+io.separator+'callNMake.bat'
		f=open(vsvarsFile,"w")
		f.write('call "'+str(self.runtime.setEnvBat())+'"\n')
		f.close()
		f=open(nmakeFile,"w")
		f.write('call "'+str(self.runtime.nmake())+'" %1 %2 \n')
		f.close()
		cmd='callVsvars32.bat & callNMake.bat /f doIt.mak'
		cwd=os.getcwd()
		os.chdir(objDir)
		print cmd
		os.system(cmd)
		os.chdir(cwd)
		resultPath=str(self.outputDir+self.outputName+('.'+str(self.output.idString())))
		if( os.path.exists(resultPath) ) :
			print '\n'
			print '"'+resultPath+'"'
			print 'created OK'
			print '\n'
		else :
			raise(Exception('doIt.mak in "'+objDir+'" failed'))
	def make(self) :
		import ots.make.generator as g
		import ots.io as io
		clauses=g.Clauses()
		macros=g.Macros()
		rules=g.Rules()
		files=[]
		for (dr,fls) in self.files :
			for f in fls :
				sn=io.ShortFileName(f)
				files.append(g.File(dirPath=dr,name=sn._name,ext=sn._ext))
		while(True) :
			if( len(files)==0 ) :
				break
			f=files.pop(0)
			processed=False
			for r in rules :
				try :
					ff=r.process(
						file=f,
						macros=macros,
						clauses=clauses,
						generator=self
					)
					if( not ff is None ) :
						files.append(ff)
					processed=True
					break
				except NotApplicable :
					pass
			if( not processed ) :
				raise(Exception('Could not find a rule for the following file:\n'+str(f)))
		import os
		objDir=str(self.objDir)
		if( not os.path.exists(objDir) ) :
			os.makedirs(objDir)
		makeFile=str(self.objDir+'doIt.mak')
		f=open(makeFile,'w')
		f.write(str(macros))
		f.write('\n')
		f.write(str(clauses))
		f.write('\n')
		f.close()
		