class IEnvironmentName(object) :
	def envName(self,**kwargs) :
		import ots.make.options as opt
		ids=self._collect('idString',**kwargs)
		ids2=self.envFilter(ids,**kwargs)
		import ots.std as std
		ids3=std.noDublicates(ids2)
		ids3.sort()
		s=""
		for x in ids3 :
			s+=(x+"_")
		s=s[:-1]
		return s
	def envInstanceFilter(self,**kwargs) :
		import ots.make.options as opt
		return [opt.Libs._Python,opt.Libs._Boost,opt.Libs._STLport]
	def envInclusionFilter(self,**kwargs) :
		import ots.make.options as opt
		r=[]
		r.extend(opt.Version.children())
		r.extend(opt.Runtime.children())
		return r
	def envFilter(self,List,**kwargs) :
		import ots.make.options as opt
		inst=self.envInstanceFilter(**kwargs)
		incl=self.envInclusionFilter(**kwargs)
		r=[]
		for (obj,id) in List :
			done=False
			for x in inst :
				if( isinstance(obj,x) ) :
					r.append(id)
					done=True
					break
			if( not done and obj in incl ) :
				r.append(id)
		return r
	def _collect(self,what,**kwargs) :
		import ots.make.options as opt
		r=[]
		for x in kwargs :
			y=kwargs[x]
			if( type(y)==type([]) ) :
				for z in y :
					try :
						r.append((z,getattr(z,what)()))
					except AttributeError,e :
						if( str(e).endswith("'"+what+"'") ) :
							continue
						else :
							raise
			else :
				try :
					r.append((y,getattr(y,what)()))
				except AttributeError,e :
					if( str(e).endswith("'"+what+"'") ) :
						continue
					else :
						raise
		return r
	
class ILib(IOption) :
	def libFileRoot(self,**kwargs) :
		raise(Exception('libFileRoot is not implemented'))
	def libPath(self,**kwargs) :
		raise(Exception('libPath is not implemented'))
	def depends(self,**kwargs) :
		return []
	#IOption
	def compile(self,**kwargs) :
		return []
	def link(self,**kwargs ) :
		import ots.make.options as opt
		r=[]
		r.append(opt.Linker.LibPath('"'+str(self.libPath(**kwargs))+'"'))
		for x in self.depends(**kwargs) :
			r.append(opt.Linker.LibPath('"'+str(x.libPath(**kwargs))+'"'))
		return r
	def libs(self,**kwargs) :
		r=[ self.libFileRoot(**kwargs)+'.lib' ]
		for x in self.depends(**kwargs) :
			r.append(x.libFileRoot(**kwargs)+'.lib')
		return r
class IBuiltLib(ILib,IEnvironmentName) :
	def sourcePath(self) :
		raise(Exception('sourcePath is not implemented'))
	def libFileRoot(self,**kwargs) :
		return self.idString()+'_'+self.envName(**kwargs)
	def libPath(self,**kwargs) :
		import ots.make.options as opt
		return opt.CDrive+"OTSProjects"+"Boost"+self.name()+'bin'+self.libFileRoot(**kwargs)
	def dllPath(self,**kwargs) :
		return [self.libPath(**kwargs)+self.libFileRoot(**kwargs)+'.dll']
	

class _Libs(ILevel1) :
	def name(self) :
		return "Libs"
	def children(self) :
		return [
			Libs.Python25,
			Libs.Python26,
			Libs.Python27,
			Libs.Boost_1_40,
			Libs.Boost_1_50,
			Libs.Boost_1_51,
			Libs.STLport
		]
	class _Python(ILevel2,ILib) :
		def __init__(self,version1,version2) :
			self.version=(version1,version2)
		def rootPath(self) :
			import ots.make.options as opt
			return opt.Dir.python(self.version)
		def includePath(self) :
			return self.rootPath()+"include"
		def pythonString(self) :
			return "python"+str(self.version[0])+str(self.version[1])
		def pythonSuffix(self) :
			return str(self.version[0])+str(self.version[1])
		def pythonDotSuffix(self) :
			return str(self.version[0])+'.'+str(self.version[1])
		#ILevel2
		def name(self) :	
			return "Python("+str(self.version)+")"
		def parent(self) :
			return Libs
		def children(self) :
			return []
		#ILib,IOption
		def idString(self) :
			return "py"+str(self.version[0])+str(self.version[1])
		def compile(self,**kwargs) :	
			import ots.make.options as opt
			r=ILib.compile(self,**kwargs)
			r.append(opt.Compile.Include('"'+str(self.includePath())+'"'))
			return r
		def libFileRoot(self,**kwargs) :
			return "python"+str(self.version[0])+str(self.version[1])
		def libPath(self,**kwargs) :
			return self.rootPath()+"libs"
	class _Boost(ILevel2,IOption) :
		def __init__(self,version1,version2,version3) :
			self.version=(version1,version2,version3)
			self.Chrono=Libs._Boost._Chrono(self)
			self.DateTime=Libs._Boost._DateTime(self)
			self.Python=Libs._Boost._Python(self)
			self.System=Libs._Boost._System(self)
			self.Thread=Libs._Boost._Thread(self)
		def rootPath(self) :
			import ots.make.options as opt
			return opt.Dir.boost(self.version)
		def _versionString(self) :
			s=str(self.version[0])+str(self.version[1])
			if( self.version[2]!=0 ) :
				s+=str(self.version[0])
			return s
		#ILevel2
		def parent(self) :
			return Libs
		def children(self) :
			return [self.System,self.Chrono,self.DateTime,self.Python,self.Thread]	
		def name(self) :
			return "Boost("+str(self.version)+")"
		#IOption
		def idString(self) :
			return "b"+self._versionString()
		def compile(self,**kwargs) :
			import ots.make.options as opt
			return [
				opt.Compile.Preprocessor("BOOST_ALL_NO_LIB=1"),
				opt.Compile.Preprocessor("BOOST_ALL_DYN_LINK=1"),
				opt.Compile.Include('"'+str(self.rootPath())+'"')
			]
		def link(self,**kwargs) :
			return []
		def libs(self,**kwargs) :
			return []
		class _Chrono(ILevel3,IBuiltLib) :
			def __init__(self,parent) :
				self._parent=parent
			#ILevel3
			def parent(self) :
				return self._parent
			def children(self) :
				return []
			def name(self) :
				return "Chrono"
			#IOption
			def idString(self) :
				return "bCrn"
			#IBuiltLib		
			def depends(self,**kwargs) :
				return [ self.parent().System ]
			def sourcePath(self) :
				return self.parent().rootPath()+"libs"+"chrono"+"src"
			def envInstanceFilter(self,**kwargs) :
				import ots.make.options as opt
				return [opt.Libs._Boost,opt.Libs._STLport]
		class _DateTime(ILevel3,IBuiltLib) :
			def __init__(self,parent) :
				self._parent=parent
			#ILevel3
			def parent(self) :
				return self._parent
			def children(self) :
				return []
			def name(self) :
				return "DateTime"
			#IOption
			def idString(self) :
				return "bDt"
			def compile(self,**kwargs) :
				import ots.make.options as opt
				r=ILib.compile(self,**kwargs)
				r.append( opt.Compile.Preprocessor("DATE_TIME_INLINE") )
				return r
			#IBuiltLib
			def sourcePath(self) :
				return self.parent().rootPath()+"libs"+"date_time"+"src"
			def envInstanceFilter(self,**kwargs) :
				import ots.make.options as opt
				return [opt.Libs._Boost,opt.Libs._STLport]
		class _Python(ILevel3,IBuiltLib) :
			def __init__(self,parent) :
				self._parent=parent
			#ILevel3
			def parent(self) :
				return self._parent
			def children(self) :
				return []
			def name(self) :
				return "Python"
			#IOption
			def idString(self) :
				return "bPy"
			#IBuiltLib
			def sourcePath(self) :
				return self.parent().rootPath()+"libs"+"python"+"src"
		class _System(ILevel3,IBuiltLib) :
			def __init__(self,parent) :
				self._parent=parent
			#ILevel3
			def parent(self) :
				return self._parent
			def children(self) :
				return []
			def name(self) :
				return "System"
			#IOption
			def idString(self) :
				return "bSys"
			def compile(self,**kwargs) :
				import ots.make.options as opt
				r=ILib.compile(self,**kwargs)
				r.append(opt.Compile.Preprocessor("BOOST_SYSTEM_DYN_LINK=1"))
				return r
			#IBuiltLib
			def sourcePath(self) :
				return self.parent().rootPath()+"libs"+"system"+"src"
			def envInstanceFilter(self,**kwargs) :
				import ots.make.options as opt
				return [opt.Libs._Boost,opt.Libs._STLport]
		class _Thread(ILevel3,IBuiltLib) :
			def __init__(self,parent) :
				self._parent=parent
			#ILevel3
			def parent(self) :
				return self._parent
			def children(self) :
				return []
			def name(self) :
				return "Thread"
			#IOption
			def idString(self) :
				return "bTh"
			#IBuiltLib
			def depends(self,**kwargs) :
				import ots.make.options as opt
				r=[]
				r.append(self.parent().DateTime)
				r.append(self.parent().System)
				if( self.parent() in [opt.Libs.Boost_1_50,opt.Libs.Boost_1_51] ) :
					r.append(self.parent().Chrono)
				return r
			def sourcePath(self) :
				return self.parent().rootPath()+"libs"+"thread"+"src"
			def envInstanceFilter(self,**kwargs) :
				import ots.make.options as opt
				return [opt.Libs._Boost,opt.Libs._STLport]
	class _STLport(ILevel2,ILib) :
		"Should be first in a list of libraries."		
		def __init__(self,version1,version2,version3) :
			self.version=(version1,version2,version3)
		def rootPath(self) :
			import ots.make.options as opt
			return opt.Dir.stlport(self.version)
		def dllPath(self,**kwargs) :
			r=[]
			for p in self.stlpBuildPath(**kwargs) :
				for n in self.stlpLibRoot(**kwargs) :
					r.append(p+n+'.dll')
			return r
		def stlpBuildPath(self,**kwargs) :
			import ots.make.options as opt
			runtime=kwargs.get('runtime')
			version=kwargs.get('version')
			if( runtime==opt.Runtime.Msvc9 and version==opt.Version.Debug) :
				return [
					self.rootPath()+'build'+'lib'+'obj'+'vc9'+'shared-g',
					self.rootPath()+'build'+'lib'+'obj'+'vc9'+'shared-stlg'
				]
			if( runtime==opt.Runtime.Msvc71 and version==opt.Version.Debug) :
				return [
					self.rootPath()+'build'+'lib'+'obj'+'vc71'+'shared-g',
					self.rootPath()+'build'+'lib'+'obj'+'vc71'+'shared-stlg'
				]
			if( runtime==opt.Runtime.Msvc9 and version==opt.Version.Release) :
				return [
					self.rootPath()+'build'+'lib'+'obj'+'vc9'+'shared'
				]
			if( runtime==opt.Runtime.Msvc71 and version==opt.Version.Release) :
				return [
					self.rootPath()+'build'+'lib'+'obj'+'vc71'+'shared'
				]
			raise(Exception("Unexpected runtime,version parameters"))
		def stlpLibRoot(self,**kwargs) :
			import ots.make.options as opt
			version=kwargs.get('version')
			if( version==opt.Version.Debug ) :
				return [
					'stlportstld.'+str(self.version[0])+'.'+str(self.version[1]),
					'stlportd.'+str(self.version[0])+'.'+str(self.version[1])
					]
			if( version==opt.Version.Release ) :
				return ['stlport.'+str(self.version[0])+'.'+str(self.version[1])]
			raise(Exception("Unexpected version"))
			
		#ILevel2
		def name(self) :
			return "STLport("+str(self.version)+")"
		def parent(self) :
			return Libs
		def children(self) :
			return []
		#IOption
		def idString(self) :
			return "stlp"+str(self.version[0])+str(self.version[1])+str(self.version[2])
		def compile(self,**kwargs) :
			co=[]
			import ots.make.options as opt
			version=kwargs.get('version')
			if( version==opt.Version.Debug ) :
				co.append(opt.Compile.Preprocessor('_STLP_DEBUG=1'))
			co.append(opt.Compile.Include('"'+str(self.rootPath()+'stlport')+'"'))
			return co
		def link(self,**kwargs) :
			import ots.make.options as opt
			return [opt.Linker.LibPath('"'+str(x)+'"') for x in self.stlpBuildPath(**kwargs)]
		def libs(self,**kwargs) :
			return []
	
Libs=_Libs()
Libs.Python25=_Libs._Python(2,5)
Libs.Python26=_Libs._Python(2,6)
Libs.Python27=_Libs._Python(2,7)
Libs.Boost_1_40=_Libs._Boost(1,40,0)
Libs.Boost_1_50=_Libs._Boost(1,50,0)
Libs.Boost_1_51=_Libs._Boost(1,51,0)
Libs.STLport=_Libs._STLport(5,2,1)

