import numpy as _n
def _randomInteger() :
	return int(_n.ceil(_n.random.uniform(low=1.0,high=1000000.0,size=1)[0]))

import time as _time
def _smallRandomDelay() :
	_time.sleep(_n.random.uniform(low=0.0,high=smallDelaySeconds,size=1)[0])
def _tries() :
	return max(2.0*timeOutSeconds/smallDelaySeconds,2)

def writeNumber(number,fileName) :
	f=open(fileName,'w')
	f.write(str(int(number)))
	f.write('\n')
	f.close()
def readNumber(fileName) :
	f=open(fileName,'r')
	x=f.readline()
	f.close()
	return int(x.strip())
	
def _safeReadValue(fileName) :
	i=-1
	tries=_tries()
	while(True) :
		i=i+1
		if( i>=tries ) :
			return -1
		try :
			return readNumber(fileName=fileName)
		except :
			_smallRandomDelay()
def _safeWriteValue(value,fileName) :
	i=-1
	tries=_tries()
	while(True) :
		i=i+1
		if( i>=tries ) :
			return False
		try :
			writeNumber(number=value,fileName=fileName)
			return True
		except :
			_smallRandomDelay()
		
class _Joiner(object) :
	def __init__(self,counterFile=_clientCounterFile) :
		self._counterFile=counterFile
		self._counter=-1
		self._prepareCalled=False
		self.prepare()
	def prepare(self) :
		self._counter=_safeReadValue(fileName=self._counterFile)
		if( self._counter<=0) :
			self._counter=_randomInteger()
			if(not _safeWriteValue(self._counter,fileName=self._counterFile)) :
				raise(Exception('Unable to write into the file "'+self._counterFile+'"'))
		self._prepareCalled=True
	def join(self) :
		if(not self._prepareCalled) :
			raise(Exception('_Joiner--> prepare has to be called before join.'))
		self._prepareCalled=False
		x=_safeReadValue(fileName=self._counterFile)
		while(x==self._counter) :
			_smallRandomDelay()
			x=_safeReadValue(fileName=self._counterFile)
			
_joiner=_Joiner()


class _Signaller(object) :
	def __init__(self,counterFile=_serverCounterFile) :
		self._counterFile=counterFile
		self._counter=-1
		self._prepareCalled=False
		self.prepare()
	def prepare(self) :
		self._counter=_safeReadValue(fileName=self._counterFile)
		if( self._counter<=0) :
			self._counter=_randomInteger()
			if(not _safeWriteValue(self._counter,fileName=self._counterFile)) :
				raise(Exception('Unable to write into the file "'+self._counterFile+'"'))
		self._prepareCalled=True
	def signal(self) :
		if( not self._prepareCalled ) :
			raise(Exception('_Signaller--> prepare must be called before the signal is called.'))
		self._prepareCalled=False
		x=_randomInteger()
		while( self._counter==x ) :
			x=_randomInteger()
		self._counter=x
		if(not _safeWriteValue(self._counter,fileName=self._counterFile)) :
			raise(Exception('Unable to write into the file "'+self._counterFile+'"'))
	def abort(self) :
		_safeWriteValue(-1,self._counterFile)
		
_signaller=_Signaller()

class RReply(Exception) :
	def __init__(self,msg) :
		super(RReply,self).__init__(msg)
		
def _reply() :
	f=open(_replyFile,'r')
	toReply=[]
	i=0
	while(True) :
		try :
			x=f.readline()
		except :
			break
		if x is None or x=='':
			if i>10 :
				break
			i=i+1
		else :
			i=0
			toReply.append(x)
	f.close()
	i=len(toReply)-1
	while(i>=0) :
		if( toReply[i] is None or toReply[i].strip()=='' ) :
			i=i-1
		else :
			break
	msg=''
	for j in range(0,i+1) :
		msg=msg+str(toReply[j])
	if( msg.strip()=='' ) :
		return
	raise RReply(msg)
	
class Barrier(object) :
	def __init__(self) :
		_joiner.prepare()
		_signaller.prepare()
	def wait(self) :
		_signaller.signal()
		_joiner.join()
		_reply()
	def abort(self) :
		_signaller.abort()
		_joiner.join()
		_reply()
		