
class _Channel(object) :
	def __init__(self) :
		self._typeReprMap={}
		self._classNameMap={}
	def register(self,method) :
		if(hasattr(method,'typeRepr')) :
			self._typeReprMap[method.typeRepr]=method
		if(hasattr(method,'className')) :
			self._classNameMap[method.className]=method
	def write(self,obj,fileName=_dataFile) :
		try:
			method=self._typeReprMap[repr(type(obj))]
		except KeyError :
			raise(Exception('Such object type='+repr(type(obj))+' is not supported.'))
		file=open(fileName,'w')
		try :
			method.write(file,obj)
			file.close()
			return
		except :
			file.close()
			raise
	def read(self,fileName=_dataFile) :
		file=open(fileName,'r')
		className=file.readline().strip()
		try:
			method=self._classNameMap[className]
		except KeyError :
			file.close()
			raise(Exception('Such className='+repr(className)+' is not supported.'))
		try :
			obj=method.read(file)
			file.close()
			return obj
		except :
			file.close()
			raise
	def command(self,command,fileName=_commandFile) :
		f=open(fileName,'w')
		try :
			f.write(command)
		except :
			f.close()
			raise
		f.close()
	def sendFor(self,objName) :
		self.command('pyServer.write('+str(objName)+')')
	def set(self,name,obj) :
		self.write(obj)
		self.command(name+'=pyServer.read()')
	def assembleIO(self) :
		cmd1="""
				pyServer.write=function(Value,fileName=pyServer.dataFile)
				{
					File=file(fileName,open='w')
					Class=class(Value)
					Mode=mode(Value)
					Length=length(Value)
			"""
		cmd2="""
					<if or else if>(Class=='<className>')
					{
						<classWrite>
					}
			"""
		cmd3="""
					else
					{
						close(File)
						stop(paste('Unexpected Value in pyServer.write, class=',toString(class(Value))))
					}
					close(File)
				}
			"""
		cmd=cmd1
		ifStr='if'
		for k in self._classNameMap :
			x=cmd2.replace('<if or else if>',ifStr) \
					.replace('<classWrite>',self._classNameMap[k].classWrite()) \
					.replace('<className>',self._classNameMap[k].className)
			ifStr='else if'
			cmd=cmd+x
		cmd=cmd+cmd3
		cmd1="""
				pyServer.read=function(fileName=pyServer.dataFile)
				{
					File=file(fileName,open='r')
					Class=readLines(File,n=1)
			"""
		cmd2="""
					<if or else if>(Class=='<className>')
					{
						<classRead>
					}
			"""
		cmd3="""
					else
					{
						close(File)
						stop(paste('Unexpected Value in pyServer.read, class=',toString(class(Value))))
					}
					close(File)
					Result
				}
			"""
		cmd=cmd+'\n\n'
		cmd=cmd+cmd1
		ifStr='if'
		for k in self._classNameMap :
			x=cmd2.replace('<if or else if>',ifStr) \
					.replace('<classRead>',self._classNameMap[k].classRead()) \
					.replace('<className>',self._classNameMap[k].className)
			ifStr='else if'
			cmd=cmd+x
		cmd=cmd+cmd3
		cmd=cmd+'\n\n'
		self.command(cmd)
		
		
_channel=_Channel()
def _register(method) :
	_channel.register(method)

