

class _Numeric(object) :
	def __init__(self) :
		self.className='numeric'
	def read(self,file) :
		L=int(file.readline().strip())
		result=[]
		for i in range(0,L) :
			result.append(float(file.readline().strip()))
		return result
	def classWrite(self) :
		return """
					pyServer.writeLines(c(Class,Length),File)
					pyServer.writeLines(Value,File)
				"""
	def classRead(self) :
		return """
					L=as.numeric(readLines(File,n=1))
					Result=as.numeric(readLines(File,n=L))		
				"""
class _Character(object) :
	def __init__(self) :
		self.className='character'
	def read(self,file) :
		L=int(file.readline().strip())
		result=[]
		for i in range(0,L) :
			result.append(file.readline().strip())
		return result
	def classWrite(self) :
		return """
					pyServer.writeLines(c(Class,Length),File)
					pyServer.writeLines(Value,File)
				"""
	def classRead(self) :
		return """
					L=as.numeric(readLines(File,n=1))
					Result=readLines(File,n=L)
				"""
def write(file,obj) :
	file.write(str(obj)+'\n')
class _List(object) :
	def __init__(self) :
		self.typeRepr=repr(type([]))
	def write(self,file,obj) :
		C='numeric'
		for x in obj :
			if(not (type(x)==type(float(0)) or type(x)==type(int(0)))) :
				C='character'
				break
		write(file,C)
		write(file,len(obj))
		for x in obj :
			write(file,x)
_register(_Numeric())
_register(_Character())
_register(_List())

class _Str(object) :
	def __init__(self) :
		self.typeRepr=repr(type(''))
	def write(self,file,obj) :
		write(file,'character')
		write(file,1)
		write(file,obj)
class _Int(object) :
	def __init__(self) :
		self.typeRepr=repr(type(int(0)))
	def write(self,file,obj) :
		write(file,'numeric')
		write(file,1)
		write(file,obj)
class _Float(object) :
	def __init__(self) :
		self.typeRepr=repr(type(float(0)))
	def write(self,file,obj) :
		write(file,'numeric')
		write(file,1)
		write(file,obj)
_register(_Str())
_register(_Int())		
_register(_Float())


import numpy as _n
class _MatrixR(object) :
	def __init__(self) :
		self.className='matrix'
	def read(self,file) :
		mode=file.readline().strip()
		L=int(file.readline().strip())
		d1=int(file.readline().strip())
		d2=int(file.readline().strip())
		data=[]
		for i in range(0,L) :
			data.append(file.readline().strip())
		if( mode=='character' ) :
			result=[]
			for i in range(0,d1) :
				r=[]
				for j in range(0,d2) :
					r.append('')
				result.append(r)
			for i in range(0,d1) :
				for j in range(0,d2) :
					result[i][j]=data[i+j*(d2-1)]
			return result
		if( mode=='numeric' ) :
			result=_n.matrix(_n.ndarray(shape=(d1,d2)))
			for i in range(0,d1) :
				for j in range(0,d2) :
					result[i,j]=float(data[i+j*(d2-1)])
			return result
		raise(Exception('Incorrect mode='+repr(mode)+' in matrix('+repr(file)+')'))
	def classWrite(self) :
		return """
					pyServer.writeLines(c(Class,Mode,Length,dim(Value)),File)
					pyServer.writeLines(Value,File)
				"""
	def classRead(self) :
		return """
					M=readLines(File,n=1)
					L=as.numeric(readLines(File,n=1))
					D1=as.numeric(readLines(File,n=1))
					D2=as.numeric(readLines(File,n=1))
					Result=readLines(File,n=L)
					if(M=='numeric')
						Result=as.numeric(Result)
					else if(M!='character')
						stop(paste('Unexpected mode in io.read, mode=',toString(M)))		
					dim(Result)=c(D1,D2)
				"""
class _MatrixPy(object) :
	def __init__(self) :
		self.typeRepr=repr(type(_n.matrix([[0]])))
	def write(self,file,obj) :
		write(file,'matrix')
		write(file,'numeric')
		write(file,obj.size)
		write(file,obj.shape[0])
		write(file,obj.shape[1])
		for j in range(0,obj.shape[1]) :
			for i in range(0,obj.shape[0]) :
				write(file,obj[i,j])
_register(_MatrixR())
_register(_MatrixPy())



