import poly
import time
import numpy
import decimal
import math_com
m=math_com.m

f1=centeredInterval=poly.PiecewisePoly([(poly.Poly([1]),poly.Piece(-0.5,0.5))])
f2=centeredHut=poly.PiecewisePoly([(poly.Poly([1,1]),poly.Piece(-1,0)),(poly.Poly([1,-1]),poly.Piece(0,1))])
f3=centeredHutIntegralZero=poly.PiecewisePoly( \
	[(poly.Poly([-2,-1]),poly.Piece(-2,-1)),(poly.Poly([2,3]),poly.Piece(-1,0)), \
	(poly.Poly([2,-3]),poly.Piece(0,1)),(poly.Poly([-2,1]),poly.Piece(1,2))] \
	)

f=centeredHut	
	
def rTo01(x) :
	return (numpy.arctan(x)+0.5*numpy.pi)/numpy.pi

	
import r_com
def plotPoly(func,N=10000,a=None,b=None) :
	"Plot a PiecewisePoly-nomial via r_com"
	if( a is None or b is None ) :
		spt=func.support()
		a=numpy.floor(spt.a())
		b=numpy.ceil(spt.b())
	h=1.0*(b-a)/N
	x=[a+h*i for i in range(0,N+1)]
	y=[func(xx) for xx in x]
	r_com.r.set('x',x)
	r_com.r.set('y',y)
	r_com.r.plot(r_com.r('x'),r_com.r('y'))
pp=plotPoly
	
def integrateN(func,N=1000,a=None,b=None) :
	"Crude numeric integration of a callable object"
	if( a is None or b is None ) :
		spt=func.support()
		a=numpy.floor(spt.a()-1)
		b=numpy.ceil(spt.b()+1)
	h=1.0*(b-a)/N
	x=[a+h*i for i in range(0,N+1)]
	y=[func(xx) for xx in x]
	s=numpy.sum(y)
	if( type(s)==decimal.Decimal ) :
		return s*poly.ToDecimal(h)
	return numpy.sum(y)*h
	
def Scalar(f1,f2) :
	"L2 scalar product of two PiecewisePoly-nomials"
	if( f1.support().intersect(f2.support()).len()==0 ) :
		return decimal.Decimal(0)
	else :
		return (f1*f2).integral()
def scalar(f1,f2,I) :
	"L2 scalar product of two PiecewisePoly-nomials"
	if( f1.support().intersect(f2.support()).intersect(I).len()==0 ) :
		return decimal.Decimal(0)
	else :
		return (f1*f2).integral(I)
def Dist(f1,f2) :
	d=f1-f2
	return numpy.sqrt(Scalar(d,d))
def dist(f1,f2,I) :
	d=f1-f2
	return numpy.sqrt(scalar(d,d,I))
def L2Norm(f) :
	return numpy.sqrt(Scalar(f,f))
def l2Norm(f,I) :
	return numpy.sqrt(scalar(f,f,I))

def scalarW12(f1,f2,I) :
	"W12 scalar product of two PiecewisePoly-nomials"
	if( f1.support().intersect(f2.support()).intersect(I).len()==0 ) :
		return decimal.Decimal(0)
	else :
		return (f1*f2).integral(I)+(poly.D(f1)*poly.D(f2)).integral(I)
def distW12(f1,f2,I) :
	d=f1-f2
	return numpy.sqrt(scalarW12(d,d,I))
def w12Norm(f,I) :
	return numpy.sqrt(scalarW12(f,f,I))


	
def condN(A) :
	import scipy.linalg as la
	(lam,Q)=la.eig(A)
	return max(lam)/min(lam)
	


parab=poly.PiecewisePoly([(poly.Poly(2),poly.Piece(-2,2))])				
cubic=poly.PiecewisePoly([(poly.Poly([1,2,3,4]),poly.Piece(-2,2))])

saveDir='c:\\otsprojects\\python\\wavelet\\data\\'
def save(obj,fileName='__data__') :
	import io
	io.save(obj,fileName,saveDir)
def load(fileName='__data__') :
	import io
	return io.load(fileName,saveDir)
	
x0=poly.PiecewisePoly([(poly.Poly([1]),poly.Piece(-100,100))])
x1=poly.PiecewisePoly([(poly.Poly([0,1]),poly.Piece(-100,100))])
x2=poly.PiecewisePoly([(poly.Poly([0,0,1]),poly.Piece(-100,100))])
x3=poly.PiecewisePoly([(poly.Poly([0,0,0,1]),poly.Piece(-100,100))])
x4=poly.PiecewisePoly([(poly.Poly([0,0,0,0,1]),poly.Piece(-100,100))])
x5=poly.PiecewisePoly([(poly.Poly([0,0,0,0,0,1]),poly.Piece(-100,100))])
x6=poly.PiecewisePoly([(poly.Poly([0,0,0,0,0,0,1]),poly.Piece(-100,100))])
x7=poly.PiecewisePoly([(poly.Poly([0,0,0,0,0,0,0,1]),poly.Piece(-100,100))])
x8=poly.PiecewisePoly([(poly.Poly([0,0,0,0,0,0,0,0,1]),poly.Piece(-100,100))])
x9=poly.PiecewisePoly([(poly.Poly([0,0,0,0,0,0,0,0,0,1]),poly.Piece(-100,100))])
x10=poly.PiecewisePoly([(poly.Poly([0,0,0,0,0,0,0,0,0,0,1]),poly.Piece(-100,100))])

I01=poly.Piece(0,1)

def scalingEquationFileName(n,stepA,stepB,spline) :
	return 'scalingEq_n'+str(n)+'_stepA'+str(stepA)+'_stepB'+str(stepB)+'_spline'+str(spline)
def cascadeFileName(n,spline,steps) :
	return 'n'+str(n)+'_spline'+str(spline)+'_steps'+str(steps)
def scaleFileName(n,spline,steps) :
	return 'n'+str(n)+'_scale'+str(spline)+'_steps'+str(steps)
def scale2FileName(n,spline,steps,d) :
	return 'n'+str(n)+'_scale2_'+str(spline)+'_steps'+str(steps)+'_d'+str(d)
def pwrApproxOnLineFileName(n,stepB,spline,width,maxPwr) :
	s='pwrApproxOnLine'
	s+='_n'+str(n)
	s+='_stepB'+str(stepB)
	s+='_spline'+str(spline)
	s+='_width'+str(width)
	s+='_maxPwr'+str(maxPwr)
	return s
def orthTestOnLineFileName(n,stepB,spline,width,depth) :
	s='orthTestOnLine'
	s+='_n'+str(n)
	s+='_stepB'+str(stepB)
	s+='_spline'+str(spline)
	s+='_width'+str(width)
	s+='_depth'+str(depth)
	return s
def momentsTestOnLineFileName(n,stepB,spline,maxPwr) :
	s='momentsTestOnLine'
	s+='_n'+str(n)
	s+='_stepB'+str(stepB)
	s+='_spline'+str(spline)
	s+='_maxPwr'+str(maxPwr)
	return s	
def phiGenFileName(n,step,spline,d) :
	return 'n'+str(n)+'_pg_st'+str(step)+'_spl'+str(spline)+'_d'+str(d)
def psiGenFileName(n,step,spline,d) :
	return 'n'+str(n)+'_psiGen_st'+str(step)+'_spl'+str(spline)+'_d'+str(d)
def psiGen2FileName(n,step,spline,d) :
	return 'n'+str(n)+'_psiGen2_st'+str(step)+'_spl'+str(spline)+'_d'+str(d)
def subspaceApproxTestFileName(n,step,spline,d) :
	return 'subspaceApprox_n'+str(n)+'_st'+str(step)+'_spl'+str(spline)+'_d'+str(d)
def intervalBiorTestFile(n,step,spline,d1,d2) :
	return 'n'+str(n)+'_intBior_st'+str(step)+'_spl'+str(spline)+'_d1'+str(d1)+'_d2'+str(d2)
def intervalApproxTestFile(n,step,spline,d) :
	return 'n'+str(n)+'_intApprox_st'+str(step)+'_spl'+str(spline)+'_d'+str(d)
def intervalApproxTest2File(n,step,spline,d) :
	return 'n'+str(n)+'_intApprox2_st'+str(step)+'_spl'+str(spline)+'_d'+str(d)
	
	

def GrammMatrix(f,I) :
	a=[]
	N=len(f)
	k=0
	for x in f :
		print 'GrammMatrix, k='+str(k)+' of '+str(N)
		k+=1
		aa=[]
		a.append(aa)
		for y in f :
			aa.append(scalar(x,y,I))
	return numpy.matrix(a)
def GrammInv(f,I) :
	m=GrammMatrix(f,I)
	print 'GrammInv, condN='+str(condN(m))
	return poly.ToDecimal(m.I)
def ScalarColumn(u,f,I) :
	a=[]
	for x in f :
		a.append([scalar(u,x,I)])
	return numpy.matrix(a)
def Projection(u,f,grammInv,I) :
	print 'calculating projection'
	b=ScalarColumn(u=u,f=f,I=I)
	c=grammInv*b
	proj=poly.PiecewisePoly()
	for k in range(0,len(f)) :
		proj+=f[k]*c[k,0]
	print 'projection done'
	return proj
def GrammSchmidt(f,I) :
	print 'GrammSchmidt'
	r=[]
	for k in range(0,len(f)) :
		proj=poly.PiecewisePoly()
		for p in range(0,k) :
			c=scalar(f[k],r[p],I)
			proj+=r[p]*c
		rr=f[k]-proj
		L2=l2Norm(rr,I)
		print 'GrammSchmidt, L2='+str(L2)
		r.append(rr*(decimal.Decimal(1)/L2))
	print 'GrammSchmidt done'
	return r

def GrammMatrixW12(f,I) :
	a=[]
	N=len(f)
	k=0
	for x in f :
		print 'GrammMatrixW12, k='+str(k)+' of '+str(N)
		k+=1
		aa=[]
		a.append(aa)
		for y in f :
			aa.append(scalarW12(x,y,I))
	return numpy.matrix(a)
def GrammInvW12(f,I) :
	m=GrammMatrixW12(f,I)
	print 'GrammInvW12, condN='+str(condN(m))
	return poly.ToDecimal(m.I)
def ScalarColumnW12(u,f,I) :
	a=[]
	for x in f :
		a.append([scalarW12(u,x,I)])
	return numpy.matrix(a)
def ProjectionW12(u,f,grammInvW12,I) :
	print 'calculating projection w12'
	b=ScalarColumnW12(u=u,f=f,I=I)
	c=grammInvW12*b
	proj=poly.PiecewisePoly()
	for k in range(0,len(f)) :
		proj+=f[k]*c[k,0]
	print 'projection done'
	return proj
def GrammSchmidtW12(f,I) :
	print 'GrammSchmidtW12'
	r=[]
	for k in range(0,len(f)) :
		proj=poly.PiecewisePoly()
		for p in range(0,k) :
			c=scalarW12(f[k],r[p],I)
			proj+=r[p]*c
		rr=f[k]-proj
		W12=w12Norm(rr,I)
		print 'GrammSchmidt, W12='+str(W12)
		r.append(rr*(decimal.Decimal(1)/W12))
	print 'GrammSchmidtW12 done'
	return r
	
		