import poly
import numpy
import scipy.linalg as la
import time
import decimal

def Getter1(Self,attr,k) :
	try :
		if( getattr(Self,attr) is None ) :
			setattr(Self,attr,{})
	except :
		setattr(Self,attr,{})
	a=getattr(Self,attr)
	if( not a[k] is None ) :
		return a[k]
	else :
		raise(Exception("exit from Getter1"))
def Getter2(Self,attr,m,k) :
	try :
		if( getattr(Self,attr) is None ) :
			setattr(Self,attr,{})
	except :
		setattr(Self,attr,{})
	a=getattr(Self,attr)
	try :
		if( a[m] is None ) :
			a[m]={}
	except :
		a[m]={}
	if(not a[m][k] is None ) :
		return a[m][k]
	else :
		raise(Exception("exit from Getter2"))

def GrammSchmidt(f,I,kernel=None) :
	r=[]
	N=len(f)
	for k in range(0,N) :
		proj=poly.PiecewisePoly()
		for p in range(0,k) :
			prd=f[k]*r[p]
			if( not kernel is None ) :
				prd*=kernel
			c=prd.integral(I)
			proj+=r[p]*c
		rr=f[k]-proj
		sq=rr*rr
		if( not kernel is None ) :
			sq*=kernel
		n=numpy.sqrt(sq.integral(I))
		n=decimal.Decimal(1)/n
		r.append(rr*n)
	return r
def GrammMatrix(f,I) :
	N=len(f)
	a=[]
	for i in range(0,N) :
		print 'GrammMatrix, (i,N)='+str((i,N))
		aa=[]
		a.append(aa)
		for j in range(0,N) :
			if( f[i].support().intersect(f[j].support()).intersect(I).len()>0 ) :
				aa.append((f[i]*f[j]).integral(I))
			else :
				aa.append(decimal.Decimal(0))
	return numpy.matrix(a)
def Projection(u,f,I) :
	ff=[]
	for v in f :
		if( v.support().intersect(u.support()).intersect(I).len()>0 ) :
			ff.append(v)
	return Projection2(u,ff,I)[0]
def Projection2(u,f,I) :
	N=len(f)
	A=GrammMatrix(f,I)
	b=[]
	for i in range(0,N) :
		b.append([(f[i]*u).integral(I)])
	b=numpy.matrix(b)
	c=poly.ToDecimal(A.I)*b
	r=poly.PiecewisePoly()
	for i in range(0,N) :
		r+=f[i]*c[i,0]
	cc=[c[i,0] for i in range(0,N)]
	return (r,cc)
 
	
		
class PsiGenerator(object) :
	"""
	Source of psi/Psi-basis on [0,1].
	"""
	def __init__(self,dGenerator,dp1Generator,psi,Psi) :
		self._dGen=dGenerator
		self._dp1Gen=dp1Generator
		self._psi=psi
		self._Psi=Psi
		self._I01=poly.Piece(0,1)
		self._kI=self._dGen._kI
		self._kL=self._dGen._kL
		self._kR=self._dGen._kR
		self._kk=self._dGen._kk
		self._d=self._dGen._d
		self._n=self._dGen._n
		self._phi=self._dGen._phi
		self._Phi=self._dGen._Phi
		if( not self._phi.support()==self._Phi.support() ) :
			raise(Exception('Supports are different'))
		if( not self._dGen._n==self._dGen._N ) :
			raise(Exception('N are different'))
	def zid(self,k) :
		try :
			return Getter1(self,"_zidk",k)
		except :
			pass
		kL0=self._dGen._kI[0]-1
		kR0=self._dGen._kI[-1]+1
		kL1=self._dp1Gen._kI[0]-1
		kR1=self._dp1Gen._kI[-1]+1
		N=self._dGen._n
		I=self._I01
		if( kL0-N<k and k<=kL0 ) :
			k2=k+kL1-kL0
			xsi1=self._dp1Gen.xsid(k2)
			s=poly.PiecewisePoly()
			for m in self._dGen._kk :
				dual=self._dGen.Xsid(m)
				if( xsi1.support().intersect(dual.support()).intersect(I).len()>0 ) :
					c=(xsi1*dual).integral(I)
					s+=self._dGen.xsid(m)*c
			r=xsi1-s
			self._zidk[k]=r
			return r
		if( kR0<=k and k<kR0+N ) :
			k2=k+kR1-kR0
			xsi1=self._dp1Gen.xsid(k2)
			s=poly.PiecewisePoly()
			for m in self._dGen._kk :
				dual=self._dGen.Xsid(m)
				if( xsi1.support().intersect(dual.support()).intersect(I).len()>0 ) :
					c=(xsi1*dual).integral(I)
					s+=self._dGen.xsid(m)*c
			r=xsi1-s
			self._zidk[k]=r
			return r
		raise(Exception('Unexpected index'))
	def Zid(self,k) :
		try :
			return Getter1(self,"_Zidk",k)
		except :
			pass
		kL0=self._dGen._kI[0]-1
		kR0=self._dGen._kI[-1]+1
		kL1=self._dp1Gen._kI[0]-1
		kR1=self._dp1Gen._kI[-1]+1
		N=self._dGen._n
		I=self._I01
		if( kL0-N<k and k<=kL0 ) :
			k2=k+kL1-kL0
			Xsi1=self._dp1Gen.Xsid(k2)
			s=poly.PiecewisePoly()
			for m in self._dGen._KK :
				dual=self._dGen.xsid(m)
				if( Xsi1.support().intersect(dual.support()).intersect(I).len()!=0 ) :
					c=(Xsi1*dual).integral(I)
					s+=self._dGen.Xsid(m)*c
			r=Xsi1-s
			self._Zidk[k]=r
			return r
		if( kR0<=k and k<kR0+N ) :
			k2=k+kR1-kR0
			Xsi1=self._dp1Gen.Xsid(k2)
			s=poly.PiecewisePoly()
			for m in self._dGen._KK :
				dual=self._dGen.xsid(m)
				if( Xsi1.support().intersect(dual.support()).intersect(I).len()!=0 ) :
					c=(Xsi1*dual).integral(I)
					s+=self._dGen.Xsid(m)*c
			r=Xsi1-s
			self._Zidk[k]=r
			return r
		raise(Exception('Unexpected index'))
	def X1(self) :
		try :
			return self._X1
		except :
			pass
		kL=self._dGen._kI[0]-1
		N=self._dGen._n
		I=self._I01
		a=[]
		for i in range(0,N) :
			t1=time.clock()
			print "X1: i="+str(i)
			aa=[]
			a.append(aa)
			for j in range(0,N) :
				aa.append((self.zid(kL-i)*self.Zid(kL-j)).integral(I))
			t2=time.clock()
			print "time="+str(t2-t1)
		self._X1=numpy.matrix(a)
		return self._X1
	def X2(self) :
		try :
			return self._X2
		except :
			pass
		kR=self._dGen._kI[-1]+1
		N=self._dGen._n
		I=self._I01
		a=[]
		for i in range(0,N) :
			t1=time.clock()
			print "X2: i="+str(i)
			aa=[]
			a.append(aa)
			for j in range(0,N) :
				aa.append((self.zid(kR+i)*self.Zid(kR+j)).integral(I))
			t2=time.clock()
			print "time="+str(t2-t1)
		self._X2=numpy.matrix(a)
		return self._X2
	def aA1(self) :
		try :
			return self._aA1
		except :
			pass
		X1=self.X1()
		(p,l,u)=la.lu(X1)
		p=numpy.matrix(p)
		l=numpy.matrix(l)
		u=numpy.matrix(u)
		a=numpy.matrix(la.inv(l))*numpy.matrix(la.inv(p))
		A=numpy.matrix(la.inv(u)).transpose()
		self._aA1=(a,A)
		return self._aA1	
	def aA2(self) :
		try :
			return self._aA2
		except :
			pass
		X2=self.X2()
		(p,l,u)=la.lu(X2)
		p=numpy.matrix(p)
		l=numpy.matrix(l)
		u=numpy.matrix(u)
		a=numpy.matrix(la.inv(l))*numpy.matrix(la.inv(p))
		A=numpy.matrix(la.inv(u)).transpose()
		self._aA2=(a,A)
		return self._aA2	
	def chid(self,k0) :
		try :
			return Getter1(self,'_chid',k0)
		except :
			pass
		kI=self._dGen._kI
		kL=kI[0]-1
		kR=kI[-1]+1
		N=self._dGen._n
		if( k0 in kI ) :
			return poly.Op(self._psi,self._dGen._d,k0)
		if( kL-N<k0 and k0<=kL ) :
			(a,A)=self.aA1()
			r=poly.PiecewisePoly()
			i0=kL-k0
			for j in range(0,N) :
				r+=self.zid(kL-j)*a[i0,j]
			self._chid[k0]=r
			return r
		if( kR<=k0 and k0<kR+N ) :
			(a,A)=self.aA2()
			r=poly.PiecewisePoly()
			i0=k0-kR
			for j in range(0,N) :
				r+=self.zid(kR+j)*a[i0,j]
			self._chid[k0]=r
			return r
		raise(Exception('Unexpected k0'))
	def Chid(self,k0) :
		try :
			return Getter1(self,'_Chid',k0)
		except :
			pass
		kI=self._dGen._kI
		kL=kI[0]-1
		kR=kI[-1]+1
		N=self._dGen._n
		if( k0 in kI ) :
			return poly.Op(self._Psi,self._dGen._d,k0)
		if( kL-N<k0 and k0<=kL ) :
			(a,A)=self.aA1()
			r=poly.PiecewisePoly()
			i0=kL-k0
			for j in range(0,N) :
				r+=self.Zid(kL-j)*A[i0,j]
			self._Chid[k0]=r
			return r
		if( kR<=k0 and k0<kR+N ) :
			(a,A)=self.aA2()
			r=poly.PiecewisePoly()
			i0=k0-kR
			for j in range(0,N) :
				r+=self.Zid(kR+j)*A[i0,j]
			self._Chid[k0]=r
			return r
		raise(Exception('Unexpected k0'))
	def makeDp1(self) :
		r=PsiGenerator(
			dGenerator=self._dp1Gen,
			dp1Generator=self._dp1Gen.makeDp1(),
			psi=self._psi,
			Psi=self._Psi
			)
		r._Chid={}
		r._chid={}
		#find k_d on left
		maxK0=self._dGen._kL[-1]
		maxK1=self._dp1Gen._kL[-1]
		spt0=self._dGen.xsid(maxK0).support()
		spt1=poly.Op(r._phi.support(),self._d+1,maxK1)
		diff=10
		kD=-1000
		for k in range(0,len(self._dp1Gen._kI)+2*len(self._dp1Gen._kL)+1) :
			sptA=poly.Op(spt0,1,k)
			d=numpy.abs(sptA.b()-spt1.b())
			if( d<diff ) :
				diff=d
				kD=k
			sptA=poly.Op(spt0,1,-k)
			d=numpy.abs(sptA.b()-spt1.b())
			if( d<diff ) :
				diff=d
				kD=-k
		kL=kD
		print 'kL='+str(kL)
		#find k_d on right
		minK0=self._dGen._kR[0]
		minK1=self._dp1Gen._kR[0]
		spt0=self._dGen.xsid(minK0).support()
		spt1=poly.Op(self._phi.support(),self._d+1,minK1)
		diff=10
		kD=-1000
		for k in range(0,len(self._dp1Gen._kI)+2*len(self._dp1Gen._kL)+1) :
			sptA=poly.Op(spt0,1,k)
			d=numpy.abs(sptA.b()-spt1.b())
			if( d<diff ) :
				diff=d
				kD=k
			sptA=poly.Op(spt0,1,-k)
			d=numpy.abs(sptA.b()-spt1.b())
			if( d<diff ) :
				diff=d
				kD=-k
		kR=kD	
		print 'kR='+str(kR)
		for i in range(0,self._n) :
			print 'wavelets '+str(i)
			r._chid[r._kI[0]-1-i]=poly.Op(self.chid(self._kI[0]-1-i),1,kL)
			r._Chid[r._kI[0]-1-i]=poly.Op(self.Chid(self._kI[0]-1-i),1,kL)
			r._chid[r._kI[-1]+1+i]=poly.Op(self.chid(self._kI[-1]+1+i),1,kR)
			r._Chid[r._kI[-1]+1+i]=poly.Op(self.Chid(self._kI[-1]+1+i),1,kR)
		return r
		

class PsiGenerator2(object) :
	"""
	Source of psi/Psi-basis on [0,1].
	"""
	def __init__(self,dGenerator,dp1Generator,psi,Psi) :
		self._dGen=dGenerator
		self._dp1Gen=dp1Generator
		self._psi=psi
		self._Psi=Psi
		self._I01=poly.Piece(0,1)
		self._kI=self._dGen._kI
		self._kL=self._dGen._kL
		self._kR=self._dGen._kR
		self._kk=self._dGen._kk
		self._d=self._dGen._d
		self._n=self._dGen._n
		self._phi=self._dGen._phi
		self._Phi=self._dGen._Phi
		if( not self._phi.support()==self._Phi.support() ) :
			raise(Exception('Supports are different'))
		if( not self._dGen._n==self._dGen._N ) :
			raise(Exception('N are different'))
	def zid(self,k) :
		try :
			return Getter1(self,"_zidk",k)
		except :
			pass
		kL0=self._dGen._kI[0]-1
		kR0=self._dGen._kI[-1]+1
		kL1=self._dp1Gen._kI[0]-1
		kR1=self._dp1Gen._kI[-1]+1
		N=self._dGen._n
		I=self._I01
		if( kL0-N<k and k<=kL0 ) :
			try :
				self._GrammInv1
			except :
				indexes={}
				for p in range(0,N) :
					u=self._dp1Gen.xsid(kL1-p)
					for m in self._dGen._kk :
						f=self._dGen.xsid(m)
						if( u.support().intersect(f.support()).intersect(I).len()>0 ) :
							indexes[m]=f
				kk=indexes.keys()
				kk.sort()
				print 'zid2, kk='+str(kk)
				f=[]
				for i in kk :
					f.append(self._dGen.xsid(i))
				a=[]
				for i in range(0,len(f)) :
					print 'zid2, i='+str(i)
					aa=[]
					a.append(aa)
					for j in range(0,len(f)):
						aa.append((f[i]*f[j]).integral(I))
				m=numpy.matrix(a)
#				print 'zid2, gramm1 '+str(m)
				self._GrammInv1=poly.ToDecimal(m.I)
#				print 'zid2, gramm1.I '+str(self._GrammInv1)
				self._funcs1=f
			k2=k+kL1-kL0
			u=self._dp1Gen.xsid(k2)
			f=self._funcs1
			b=[]
			for m in range(0,len(f)) :
				b.append([(u*f[m]).integral(I)])
			c=self._GrammInv1*numpy.matrix(b)
			proj=poly.PiecewisePoly()
			for i in range(0,len(f)) :
				proj+=f[i]*c[i,0]
			self._zidk[k]=u-proj
			return self._zidk[k]
		if( kR0<=k and k<kR0+N ) :
			try :
				self._GrammInv2
			except :
				indexes={}
				for p in range(0,N) :
					u=self._dp1Gen.xsid(kR1+p)
					for m in self._dGen._kk :
						f=self._dGen.xsid(m)
						if( u.support().intersect(f.support()).intersect(I).len()>0 ) :
							indexes[m]=f
				kk=indexes.keys()
				kk.sort()
				print 'zid2, kk='+str(kk)
				f=[]
				for i in kk :
					f.append(self._dGen.xsid(i))
				a=[]
				for i in range(0,len(f)) :
					print 'zid2, i='+str(i)
					aa=[]
					a.append(aa)
					for j in range(0,len(f)):
						aa.append((f[i]*f[j]).integral(I))
				m=numpy.matrix(a)
#				print 'zid2, gramm2 '+str(m)
				self._GrammInv2=poly.ToDecimal(m.I)
#				print 'zid2, gramm2.I '+str(self._GrammInv2)
				self._funcs2=f
			k2=k+kR1-kR0
			u=self._dp1Gen.xsid(k2)
			f=self._funcs2
			b=[]
			for m in range(0,len(f)) :
				b.append([(u*f[m]).integral(I)])
			c=self._GrammInv2*numpy.matrix(b)
			proj=poly.PiecewisePoly()
			for i in range(0,len(f)) :
				proj+=f[i]*c[i,0]
			self._zidk[k]=u-proj
			return self._zidk[k]
		raise(Exception('Unexpected index'))			
	def chid(self,k0) :
		kI=self._dGen._kI
		kL=kI[0]-1
		kR=kI[-1]+1
		N=self._dGen._n
		if( k0 in kI ) :
			return poly.Op(self._psi,self._dGen._d,k0)
		if( kL-N<k0 and k0<=kL ) :
			return self.zid(k0)
		if( kR<=k0 and k0<kR+N ) :
			return self.zid(k0)
		raise(Exception('Unexpected k0'))
	def makeDp1(self) :
		r=PsiGenerator2(
			dGenerator=self._dp1Gen,
			dp1Generator=self._dp1Gen.makeDp1(),
			psi=self._psi,
			Psi=self._Psi
			)
		r._zid={}
		#find k_d on left
		maxK0=self._dGen._kL[-1]
		maxK1=self._dp1Gen._kL[-1]
		spt0=self._dGen.xsid(maxK0).support()
		spt1=poly.Op(r._phi.support(),self._d+1,maxK1)
		diff=10
		kD=-1000
		for k in range(0,len(self._dp1Gen._kI)+2*len(self._dp1Gen._kL)+1) :
			sptA=poly.Op(spt0,1,k)
			d=numpy.abs(sptA.b()-spt1.b())
			if( d<diff ) :
				diff=d
				kD=k
			sptA=poly.Op(spt0,1,-k)
			d=numpy.abs(sptA.b()-spt1.b())
			if( d<diff ) :
				diff=d
				kD=-k
		kL=kD
		print 'kL='+str(kL)
		#find k_d on right
		minK0=self._dGen._kR[0]
		minK1=self._dp1Gen._kR[0]
		spt0=self._dGen.xsid(minK0).support()
		spt1=poly.Op(self._phi.support(),self._d+1,minK1)
		diff=10
		kD=-1000
		for k in range(0,len(self._dp1Gen._kI)+2*len(self._dp1Gen._kL)+1) :
			sptA=poly.Op(spt0,1,k)
			d=numpy.abs(sptA.b()-spt1.b())
			if( d<diff ) :
				diff=d
				kD=k
			sptA=poly.Op(spt0,1,-k)
			d=numpy.abs(sptA.b()-spt1.b())
			if( d<diff ) :
				diff=d
				kD=-k
		kR=kD	
		print 'kR='+str(kR)
		for i in range(0,self._n) :
			print 'wavelets '+str(i)
			r._zid[r._kI[0]-1-i]=poly.Op(self.zid(self._kI[0]-1-i),1,kL)
			r._zid[r._kI[-1]+1+i]=poly.Op(self.zid(self._kI[-1]+1+i),1,kR)
		return r
		

		

class PhiGenerator(object) :
	"""
	Source of phi/Phi-basis on [0,1].
	"""
	maximalSupport=poly.Piece(-1000,1000)
	def __init__(self) :
		"""
			Constructed class must execute
			init* to be operational.
		"""
		pass
	def etad(self,k) :
		try :
			return Getter1(self,'_etad',k)
		except :
			pass
		kI=self._kI
		N=self._n
		minK=kI[0]
		maxK=kI[-1]
		if( k in kI ) :
			return self.phi(k)
		if( minK-N<=k and k<=minK-1 ) :
			self._etad[k]=self.xmdL(N-minK+k)
		elif( maxK+1<=k and k<=maxK+N ) :
			self._etad[k]=self.x1mdR(N-k+maxK)
		else :
			raise(Exception("Wrong k index in etad"))
		return self._etad[k]		
	def Etad(self,k) :
		try :
			return Getter1(self,'_Etad',k)
		except :
			pass
		KI=self._KI
		N=self._N
		minK=KI[0]
		maxK=KI[-1]
		if( k in KI ) :
			return self.Phi(k)
		if( minK-N<=k and k<=minK-1 ) :
			self._Etad[k]=self.XmdL(N-minK+k)
		elif( maxK+1<=k and k<=maxK+N ) :
			self._Etad[k]=self.X1mdR(N-k+maxK)
		else :
			raise(Exception("Wrong k index in Etad"))
		return self._Etad[k]		
	def init7(self,phi,Phi,d,n,N,kernel1=None,kernel2=None) :
		"""
		Constructs generator of bounary polynomials.
		phi - the scaling function.
		Phi - the tilde scaling function.
		d - scale.
		n - number of vanishing moments for psi.
		N - number of vanishing moments for Psi.
		"""
		self._kernel1=kernel1
		self._kernel2=kernel2
		self._doInit(phi,Phi,d,n,N)
		if( self._kernel1 is None ) :
			print "default kernel1"
			self._kernel1=poly.Op(phi,d,self._kI[0])
		if( self._kernel2 is None ) :
			print "default kernel2"
			self._kernel2=poly.Op(phi,d,self._kI[-1])
	def init8(self,phi,psi,Phi,Psi,d,precision,kernel1=None,kernel2=None) :
		"""
		Constructs generator of bounary polynomials.
		phi - the scaling function.
		Phi - the tilde scaling function.
		d - scale.
		precision - the moment is considered vanishing if it is below this number.
		"""
		n=self._numberOfVanishingMoments(psi,precision)
		N=self._numberOfVanishingMoments(Psi,precision)
		self._kernel1=kernel1
		self._kernel2=kernel2
		self._doInit(phi,Phi,d,n,N)
		if( self._kernel1 is None ) :
			print "default kernel1"
			self._kernel1=poly.Op(phi,d,self._kI[0])
		if( self._kernel2 is None ) :
			print "default kernel2"
			self._kernel2=poly.Op(phi,d,self._kI[-1])
	def phi(self,k) :
		return poly.Op(self._phi,self._d,k)
	def Phi(self,k) :
		return poly.Op(self._Phi,self._d,k)
	def xmdk(self,m,k) :
		try :
			return Getter2(self,'_xmdk',m,k)
		except :
			pass
		self._xmdk[m][k]=(self.xPower(m)*self.phi(k)).integral()
		return self._xmdk[m][k]
	def Xmdk(self,m,k) :
		try :
			return Getter2(self,'_Xmdk',m,k)
		except :
			pass
		self._Xmdk[m][k]=(self.xPower(m)*self.Phi(k)).integral()
		return self._Xmdk[m][k]
	def x1mdk(self,m,k) :
		try :
			return Getter2(self,'_x1mdk',m,k)
		except :
			pass
		self._x1mdk[m][k]=(self.x1Power(m)*self.phi(k)).integral()
		return self._x1mdk[m][k]
	def X1mdk(self,m,k) :
		try :
			return Getter2(self,'_X1mdk',m,k)
		except :
			pass
		self._X1mdk[m][k]=(self.x1Power(m)*self.Phi(k)).integral()
		return self._X1mdk[m][k]
	def xmdL(self,m) :
		try :
			return Getter1(self,'_xmdL',m)
		except :
			pass
		r=poly.PiecewisePoly()
		for k in self._kL :
			r+=self.phi(k)*self.Xmdk(m,k)
		self._xmdL[m]=r
		return self._xmdL[m]
	def XmdL(self,m) :
		try :
			return Getter1(self,'_XmdL',m)
		except :
			pass
		r=poly.PiecewisePoly()
		for k in self._KL :
			r+=self.Phi(k)*self.xmdk(m,k)
		self._XmdL[m]=r
		return self._XmdL[m]
	def x1mdR(self,m) :
		try :
			return Getter1(self,'_x1mdR',m)
		except :
			pass
		r=poly.PiecewisePoly()
		for k in self._kR :
			r+=self.phi(k)*self.X1mdk(m,k)
		self._x1mdR[m]=r
		return self._x1mdR[m]
	def X1mdR(self,m) :
		try :
			return Getter1(self,'_X1mdR',m)
		except :
			pass
		r=poly.PiecewisePoly()
		for k in self._KR :
			r+=self.Phi(k)*self.x1mdk(m,k)
		self._X1mdR[m]=r
		return self._X1mdR[m]
	def _numberOfVanishingMoments(self,psi,precision) :
		"""
		Calculates the number of vanishing moments 
		and builds powers of x
		"""
		k=0
		x=poly.PiecewisePoly([(poly.Poly([0,1]),self.maximalSupport)])
		while(True) :
			i=(poly.Pow(x,k)*psi).integral()
			print "moment "+str(k)+"="+str(i)
			if( float(abs(i))>precision ) :
				return k
			k+=1
	def xPower(self,m) :
		try :
			return Getter1(self,'_xPower',m)
		except :
			pass
		N=self._n
		if( 0<=m and m<N ) :
			I=poly.Piece(0,1)
			x=poly.PiecewisePoly([(poly.Poly([0,1]),PhiGenerator.maximalSupport)])
			f=[]
			for k in range(0,N) :
				f.append(poly.Pow(x,k))
			Lg=GrammSchmidt(f,I,kernel=self._kernel1)
			for k in range(0,N) :
				self._xPower[k]=Lg[k]
			return self._xPower[m]
		raise(Exception('Wrong index m'))
	def x1Power(self,m) :
		try :
			return Getter1(self,'_x1Power',m)
		except :
			pass
		N=self._n
		if( 0<=m and m<N ) :
			I=poly.Piece(0,1)
			x=poly.PiecewisePoly([(poly.Poly([1,-1]),PhiGenerator.maximalSupport)])
			f=[]
			for k in range(0,N) :
				f.append(poly.Pow(x,k))
			Lg=GrammSchmidt(f,I,kernel=self._kernel2)
			for k in range(0,N) :
				self._x1Power[k]=Lg[k]
			return self._x1Power[m]
		raise(Exception('Wrong index m'))
	def _doInit(self,phi,Phi,d,n,N) :
		self._I=poly.Piece(0,1)
		self._phi=phi
		self._Phi=Phi
		self._d=d
		self._n=n
		self._N=N
		r=Ksets(self._phi,self._d)
		self._k=r['K']
		self._kL=r['KL']
		self._kR=r['KR']
		self._kI=r['KI']
		if( len(self._kI)==0 ) :
			raise(Exception("Scale is too small"))
		r=Ksets(self._Phi,self._d)
		self._K=r['K']
		self._KL=r['KL']
		self._KR=r['KR']
		self._KI=r['KI']
		if( len(self._KI)==0 ) :
			raise(Exception("Scale is too small"))
		kk=range(self._kI[0]-self._n,self._kI[0])
		kk.extend(self._kI)
		kk.extend(range(self._kI[-1]+1,self._kI[-1]+self._n+1))
		self._kk=kk
		KK=range(self._KI[0]-self._n,self._KI[0])
		KK.extend(self._KI)
		KK.extend(range(self._KI[-1]+1,self._KI[-1]+self._n+1))
		self._KK=KK
	def __str__(self) :
		s="PhiGenerator(\n"
		s+="_d="+str(self._d)+'\n'
		s+="_n="+str(self._n)+'\n'
		s+="_N="+str(self._N)+'\n'
		s+="_k="+str(self._k)+'\n'
		s+="_kk="+str(self._kk)+'\n'
		s+="_kL="+str(self._kL)+'\n'
		s+="_kR="+str(self._kR)+'\n'
		s+="_kI="+str(self._kI)+'\n'
		s+="_K="+str(self._K)+'\n'
		s+="_KK="+str(self._KK)+'\n'
		s+="_KL="+str(self._KL)+'\n'
		s+="_KR="+str(self._KR)+'\n'
		s+="_KI="+str(self._KI)+'\n'
		s+=")\n"
		return s
	def __repr__(self) :
		return self.__str__()
	def X1(self) :
		try :
			return self._X1
		except :
			pass
		if( not self._kI==self._KI or not self._n==self._N or not self._kk==self._KK ) :
			raise(Exception("kI and KI are not equal"))
		kL=self._kI[0]-1
		N=self._n
		I=self._I
		a=[]
		for i in range(0,N) :
			t1=time.clock()
			print "X1: i="+str(i)
			aa=[]
			for j in range(0,N) :
				aa.append((self.etad(kL-i)*self.Etad(kL-j)).integral(I))
			a.append(aa)
			t2=time.clock()
			print "time="+str(t2-t1)
		self._X1=numpy.matrix(a)
		return self._X1
	def X2(self) :
		try :
			return self._X2
		except :
			pass
		if( not self._kI==self._KI or not self._n==self._N or not self._kk==self._KK ) :
			raise(Exception("kI and KI are not equal"))
		kR=self._kI[-1]+1
		N=self._n
		I=self._I
		a=[]
		for i in range(0,N) :
			t1=time.clock()
			print "X2: i="+str(i)
			aa=[]
			for j in range(0,N) :
				aa.append((self.etad(kR+i)*self.Etad(kR+j)).integral(I))
			a.append(aa)
			t2=time.clock()
			print "time="+str(t2-t1)
		self._X2=numpy.matrix(a)
		return self._X2
	def aA2(self) :
		try :
			return self._aA2
		except :
			pass
		if( not self._kI==self._KI or not self._n==self._N or not self._kk==self._KK ) :
			raise(Exception("kI and KI are not equal"))
		N=self._n
		X2=self.X2()
		(p,l,u)=la.lu(X2)
		p=numpy.matrix(p)
		l=numpy.matrix(l)
		u=numpy.matrix(u)
		a=numpy.matrix(la.inv(l))*numpy.matrix(la.inv(p))
		A=numpy.matrix(la.inv(u)).transpose()
		self._aA2=(a,A)
		print 'aA2'
		print (a,A)
		return self._aA2
	def aA1(self) :
		try :
			return self._aA1
		except :
			pass
		if( not self._kI==self._KI or not self._n==self._N or not self._kk==self._KK ) :
			raise(Exception("kI and KI are not equal"))
		N=self._n
		X1=self.X1()
		(p,l,u)=la.lu(X1)
		p=numpy.matrix(p)
		l=numpy.matrix(l)
		u=numpy.matrix(u)
		a=numpy.matrix(la.inv(l))*numpy.matrix(la.inv(p))
		A=numpy.matrix(la.inv(u)).transpose()
		self._aA1=(a,A)
		print 'aA1'
		print (a,A)
		return self._aA1
	def xsid(self,k0) :
		try :
			return Getter1(self,'_xsid',k0)
		except :
			pass
		if( not self._kI==self._KI or not self._n==self._N or not self._kk==self._KK ) :
			raise(Exception("kI and KI are not equal"))
		kI=self._kI
		kL=kI[0]-1
		kR=kI[-1]+1
		N=self._n
		if( k0 in kI ) :
			return self.phi(k0)
		if( kL-N<k0 and k0<=kL ) :
			(a,A)=self.aA1()
			r=poly.PiecewisePoly()
			i0=kL-k0
			for j in range(0,N) :
				r+=self.etad(kL-j)*a[i0,j]
			self._xsid[k0]=r
			return r
		if( kR<=k0 and k0<kR+N ) :
			(a,A)=self.aA2()
			r=poly.PiecewisePoly()
			i0=k0-kR
			for j in range(0,N) :
				r+=self.etad(kR+j)*a[i0,j]
			self._xsid[k0]=r
			return r
		raise(Exception('Wrong k0'))
	def Xsid(self,k0) :
		try :
			return Getter1(self,'_Xsid',k0)
		except :
			pass
		if( not self._kI==self._KI or not self._n==self._N or not self._kk==self._KK ) :
			raise(Exception("kI and KI are not equal"))
		kI=self._kI
		kL=kI[0]-1
		kR=kI[-1]+1
		N=self._n
		if( k0 in kI ) :
			return self.Phi(k0)
		if( kL-N<k0 and k0<=kL ) :
			(a,A)=self.aA1()
			r=poly.PiecewisePoly()
			i0=kL-k0
			for j in range(0,N) :
				r+=self.Etad(kL-j)*A[i0,j]
			self._Xsid[k0]=r
			return r
		if( kR<=k0 and k0<kR+N ) :
			(a,A)=self.aA2()
			r=poly.PiecewisePoly()
			i0=k0-kR
			for j in range(0,N) :
				r+=self.Etad(kR+j)*A[i0,j]
			self._Xsid[k0]=r
			return r
		raise(Exception('Wrong k0'))
	def makeDp1(self) :
		r=PhiGenerator()
		r.init7(
			phi=self._phi,
			Phi=self._Phi,
			d=self._d+1,
			n=self._n,
			N=self._N
		)
		r._Xsid={}
		r._xsid={}
		#find k_d on left
		maxK0=self._kL[-1]
		maxK1=r._kL[-1]
		spt0=self.xsid(maxK0).support()
		spt1=poly.Op(r._phi.support(),r._d,maxK1)
		diff=10
		kD=-1000
		for k in range(0,len(r._kI)+2*len(r._kL)+1) :
			sptA=poly.Op(spt0,1,k)
			d=numpy.abs(sptA.b()-spt1.b())
			if( d<diff ) :
				diff=d
				kD=k
			sptA=poly.Op(spt0,1,-k)
			d=numpy.abs(sptA.b()-spt1.b())
			if( d<diff ) :
				diff=d
				kD=-k
		kL=kD
		print 'kL='+str(kL)
		#find k_d on right
		minK0=self._kR[0]
		minK1=r._kR[0]
		spt0=self.xsid(minK0).support()
		spt1=poly.Op(r._phi.support(),r._d,minK1)
		diff=10
		kD=-1000
		for k in range(0,len(r._kI)+2*len(r._kL)+1) :
			sptA=poly.Op(spt0,1,k)
			d=numpy.abs(sptA.b()-spt1.b())
			if( d<diff ) :
				diff=d
				kD=k
			sptA=poly.Op(spt0,1,-k)
			d=numpy.abs(sptA.b()-spt1.b())
			if( d<diff ) :
				diff=d
				kD=-k
		kR=kD	
		print 'kR='+str(kR)
		for i in range(0,self._N) :
			print i
			r._xsid[r._kI[0]-1-i]=poly.Op(self.xsid(self._kI[0]-1-i),1,kL)
			r._Xsid[r._kI[0]-1-i]=poly.Op(self.Xsid(self._kI[0]-1-i),1,kL)
			r._xsid[r._kI[-1]+1+i]=poly.Op(self.xsid(self._kI[-1]+1+i),1,kR)
			r._Xsid[r._kI[-1]+1+i]=poly.Op(self.Xsid(self._kI[-1]+1+i),1,kR)
		return r

def condNumber1(phi,Phi,d,N,kernel) :
	pg=PhiGenerator()
	pg.init7(phi=phi,Phi=Phi,d=d,n=N,N=N,kernel1=kernel,kernel2=None)
	X=pg.X1()
	return (la.eig(X),pg)
	
saveDir='c:\\otsprojects\\python\\wavelet\\data\\'
def save(obj,fileName) :
	import io
	io.save(obj,fileName,saveDir)
def rTo01(x) :
	return (numpy.arctan(x)+0.5*numpy.pi)/numpy.pi
	
	
class CondNumberMinimizer(object) :
	"""
	Find best kernel for PhiGenerator.
	"""
	def __init__(self,phi,Phi,d,N) :
		self._phi=phi
		self._Phi=Phi
		self._d=d
		self._N=N
	def _callback(self,x) :
		print 'callback'
		print 'x '+str(x)
		print 'goal ' + str(self._middleData['goal'])
		print self._middleData['phiGen'].aA1()
		save(self._middleData,'middleData')
	def run(self) :
		import scipy.optimize as o
		print 'starting minimization'
		x0=[0 for i in range(0,self._N-1)]
		x0[0]=1
		self._result=o.fmin(
			func=self.goal,
			x0=x0,
			callback=self._callback,
			xtol=1e-3,
			ftol=1e-3,
			maxiter=50
			)
		save(self._result,'CondNumberMinimizerResult')
		return self._result
	def goal(self,x) :
		print 'entering goal'
		pg=PhiGenerator()
		pg.init7(
			phi=self._phi,
			Phi=self._Phi,
			d=self._d,
			n=self._N,
			N=self._N,
			kernel1=None,
			kernel2=None
		)
		kernel1=poly.PiecewisePoly()
		minK=pg._kI[0]
		for i in range(0,len(x)) :
			kernel1+=poly.Op(self._phi,self._d,minK+i)*numpy.abs(x[i])
		maxK=pg._kI[-1]
		kernel2=poly.PiecewisePoly()
		for i in range(0,len(x)) :
			kernel2+=poly.Op(self._phi,self._d,maxK-i)*numpy.abs(x[i])
		pg=PhiGenerator()
		pg.init7(
			phi=self._phi,
			Phi=self._Phi,
			d=self._d,
			n=self._N,
			N=self._N,
			kernel1=kernel1,
			kernel2=kernel2
		)
		I=poly.Piece(0,1)
		c1=(pg.xsid(minK-1)*pg.Xsid(minK)).integral(I)
		c2=(pg.xsid(minK)*pg.Xsid(minK-1)).integral(I)
		g=numpy.abs(c1)+numpy.abs(c2)
		self._middleData={}
		self._middleData['goal']=g
		self._middleData['phiGen']=pg
		self._middleData['x']=x
		print 'x='+str(x)
		print 'exiting goal='+str(g)
		return g

class PolynomialMinimizer(object) :
	"""
	Find best kernel for PhiGenerator.
	"""
	def __init__(self,phi,Phi,d,N,degree) :
		self._phi=phi
		self._Phi=Phi
		self._d=d
		self._N=N
		self._degree=degree
	def _callback(self,x) :
		print 'x' + str(x)
		print 'goal' + str(self._middleData['goal'])
		print self._middleData['phiGen'].aA1()
		save(self._middleData,'polynomialMiddleData')
	def run(self) :
		import scipy.optimize as o
		print 'starting minimization'
		x0=[0 for i in range(0,self._degree+1)]
		x0[0]=1
		self._result=o.fmin(
			func=self.goal,
			x0=x0,
			callback=self._callback,
			xtol=1e-3,
			ftol=1e-3,
			maxiter=50
			)
		save(self._result,'PolynomialMinimizerResult')
		return self._result
	def goal(self,x) :
		print 'entering goal'
		kernel=poly.PiecewisePoly([(poly.Poly([xx*xx for xx in x]),poly.Piece(-10,10))])
		pg=PhiGenerator()
		pg.init7(
			phi=self._phi,
			Phi=self._Phi,
			d=self._d,
			n=self._N,
			N=self._N,
			kernel1=kernel,
			kernel2=None
		)
		minK=pg._kI[0]
		maxK=pg._kI[-1]
		I=poly.Piece(0,1)
		c1=(pg.xsid(minK-1)*pg.Xsid(minK)).integral(I)
		c2=(pg.xsid(minK)*pg.Xsid(minK-1)).integral(I)
		g=numpy.abs(c1)+numpy.abs(c2)
		self._middleData={}
		self._middleData['goal']=g
		self._middleData['phiGen']=pg
		self._middleData['x']=x
		print 'x='+str(x)
		print 'exiting goal='+str(g)
		return g
				
def closestInt(x,d) :
	p=pow(2,d)
	iB=numpy.ceil(x*d)
	iA=numpy.floor(x*d)
	if( abs(x-iA)>abs(x-iB) ) :
		return iB/d
	return iA/d
def adjSpt(f,d=1) :
	"""
	Adjusted support: sometimes scaling function comes out
	of scaling procedure with slightly non-integer support bounds.
	This function returns the corrected support.
	"""
	if(type(f)==type(poly.PiecewisePoly())) :
		s=f.support()
	elif(type(f)==type(poly.Piece())) :
		s=f
	else :
		raise(Exception("Wrong type"))
	return poly.Piece(closestInt(s.a(),d),closestInt(s.b(),d))
def Ksets(phi,d) :
	"""
	Calculate the sets K_d,K_{d,L},K_{d,I},K_{d,L}.
	See the Notes.
	phi is the scaling function.
	d is the scale.
	"""
	spt=adjSpt(phi)
	I01=poly.Piece(0,1)
	#starting point
	k=0
	while(True) :
		if(poly.Op(spt,d,k).intersect(I01).len()>0) :
			k0=k
			break
		if(poly.Op(spt,d,-k).intersect(I01).len()>0) :
			k0=-k
			break
		k+=1
	#K
	k=k0
	while(True) :
		if(poly.Op(spt,d,k).intersect(I01).len()<=0) :
			break
		k=k-1
	Ka=k+1
	k=k0
	while(True) :
		if(poly.Op(spt,d,k).intersect(I01).len()<=0) :
			break
		k=k+1
	Kb=k-1
	K=range(Ka,Kb+1)
	#K_L,K_R
	k=K[0]
	while(True) :
		if( not poly.Op(spt,d,k).inside(0) ) :
			break
		k=k+1
	KL=range(K[0],k)
	k=K[-1]
	while(True) :
		if( not poly.Op(spt,d,k).inside(1) ) :
			break
		k=k-1
	KR=range(k+1,K[-1]+1)
	#K_I
	KI=range(KL[-1]+1,KR[0])
	#check internal supports
	if( len(KI)==0 ) :
		raise(Exception("d is too small"))
	return {'K':K,'KL':KL,'KR':KR,'KI':KI}
	
