execfile('common.py')

def doBiorthTest(dict1,dict2,interval=poly.Piece(-1000000000,1000000000)) :
	r={}
	r['function set 1']=dict1
	r['function set 2']=dict2
	r['interval of integration']=interval
	maxDif=0
	loc={}
	r1={}
	for d1 in dict1 :
		print "d1="+str(d1)
		r2={}
		for k1 in dict1[d1] :
			print "k1="+str(k1)
			r3={}
			for d2 in dict2 :
				r4={}
				for k2 in dict2[d2] :
					result=(dict1[d1][k1]*dict2[d2][k2]).integral(interval)
					expected=0
					if( d1==d2 and k1==k2 ) :
						expected=1
					dif=abs(result-expected)
					if( dif>maxDif ) :
						maxDif=dif
						loc['d1']=d1
						loc['d2']=d2
						loc['k1']=k1
						loc['k2']=k2
					r4[k2]=result
				r3[d2]=r4
			r2[k1]=r3
		r1[d1]=r2
	r['results']=r1
	r['loc']=loc
	print "maxDif="+str(maxDif)
	print "d1,k1,d2,k2="+str((d1,k1,d2,k2))
	return r
		

def doBiorTest1(phi,psi,Phi,Psi,width,depth) :
	"""
	The functions checks orthogonality properties of scaling function and wavelet.
	The results of verification are packed into a dictionary.
	"""
	r={}
	r['phi']=phi
	r['psi']=psi
	r['Phi']=Phi
	r['Psi']=Psi
	r['width']=width
	r['depth']=depth
	f={}
	ff={}
	for k in range(-width,width+1) :
		ff[k]=poly.Op(phi,0,k)
	f['scaling']=ff
	for d in range(0,depth+1) :
		print "d="+str(d)
		ff={}
		for k in range(-width,width+1) :
			ff[k]=poly.Op(psi,d,k)
		f[d]=ff
	F={}
	FF={}
	for k in range(-width,width+1) :
		FF[k]=poly.Op(Phi,0,k)
	F['scaling']=FF
	for d in range(0,depth+1) :
		print "d="+str(d)
		FF={}
		for k in range(-width,width+1) :
			FF[k]=poly.Op(Psi,d,k)
		F[d]=FF
	r['results']=doBiorthTest(f,F)
	return r
	
def doBiorTest2(psiGen1,psiGen2) :
	"""
	The functions checks orthogonality properties of wavelets on interval
	The results of verification are packed into a dictionary.
	"""
	r={}
	r['psiGen1']=psiGen1
	r['psiGen2']=psiGen2
	f={}
	ff={}
	for k in psiGen1._dGen._kk :
		ff[k]=psiGen1._dGen.xsid(k)
	f['scaling']=ff
	ff={}
	for k in psiGen1._dGen._kk :
		ff[k]=psiGen1.chid(k)
	f['1']=ff
	ff={}
	for k in psiGen2._dGen._kk :
		ff[k]=psiGen2.chid(k)
	f['2']=ff
	F={}
	FF={}
	for k in psiGen1._dGen._KK :
		FF[k]=psiGen1._dGen.Xsid(k)
	F['scaling']=FF
	FF={}
	for k in psiGen1._dGen._KK :
		FF[k]=psiGen1.Chid(k)
	F['1']=FF
	FF={}
	for k in psiGen2._dGen._KK :
		FF[k]=psiGen2.Chid(k)
	F['2']=FF
	r['results']=doBiorthTest(f,F,poly.Piece(0,1))
	return r
