import poly
import numpy

def GrammMatrix(f) :
	N=len(f)
	a=[]
	for i in range(0,N) :
		print 'GrammMatrix, (i,N)='+str((i,N))
		aa=[]
		a.append(aa)
		for j in range(0,N) :
			if( f[i].support().intersect(f[j].support()).len()>0 ) :
				aa.append((f[i]*f[j]).integral())
			else :
				aa.append(decimal.Decimal(0))
	return numpy.matrix(a)
def Projection(u,f) :
	N=len(f)
	A=GrammMatrix(f)
	b=[]
	for i in range(0,N) :
		b.append([(f[i]*u).integral()])
	b=numpy.matrix(b)
	c=poly.ToDecimal(A.I)*b
	r=poly.PiecewisePoly()
	for i in range(0,N) :
		r+=f[i]*c[i,0]
	cc=[c[i,0] for i in range(0,N)]
	return (r,cc)
def dist(f1,f2) :
	d=f1-f2
	d=d*d
	return numpy.sqrt(d.integral())
	
class ScaleOnLine(object) :
	def __init__(self,phi) :
		self._phi=phi
	def run(self) :
		phi=self._phi
		f={}
		f[0]=poly.Op(phi,1,0)
		k=1
		while(True) :
			phi1=poly.Op(phi,1,k)
			phi2=poly.Op(phi,1,-k)
			hasCommonSupport=False
			if( phi1.support().intersect(phi.support()).len()>0 ) :
				f[k]=phi1
				hasCommonSupport=True
			if( phi2.support().intersect(phi.support()).len()>0 ) :
				f[-k]=phi2
				hasCommonSupport=True
			if( not hasCommonSupport ) :
				break
			k+=1
		indexes=f.keys()
		indexes.sort()
		print indexes
		ff=[f[k] for k in indexes]
		(proj,arg)=Projection(phi,ff)
		print arg
		L2=dist(phi,proj)
		print "L2diff="+str(L2)
		r={}
		r['phi']=phi
		r['proj']=proj
		r['basis']=ff
		r['indexes']=indexes
		r['L2diff']=L2
		r['h']=arg
		return r
		