import poly
import numpy
import scipy.linalg as la

def dist(f1,f2,I) :
	d=f1-f2
	d=d*d
	return numpy.sqrt(d.integral(I))
	
class ScaleOnInterval(object) :
	def __init__(self,phiGen0,phiGen1,I) :
		self._pg0=phiGen0
		self._pg1=phiGen1
		self._I=I
	def run(self) :
		pg0=self._pg0
		pg1=self._pg1
		I=self._I
		indexes0=pg0._kk
		indexes1=pg1._kk
		#construct gramm matrix
		M1=len(indexes1)
		a=[]
		k1=indexes1[0]
		for i in range(0,M1) :
			print 'Scale GrammMatrix, (i,M1)='+str((i,M1))
			aa=[]
			a.append(aa)
			for j in range(0,M1) :
				u=pg1.xsid(k1+i)
				v=pg1.xsid(k1+j)
				if( u.support().intersect(v.support()).intersect(I).len()>0 ) :
					aa.append((u*v).integral())
				else :
					aa.append(decimal.Decimal(0))
		Gramm=numpy.matrix(a)
		print la.eig(Gramm)
		GrammInv=poly.ToDecimal(Gramm.I)
		#take projections
		M0=len(indexes0)
		a=[]
		k0=indexes0[0]
		L2=[]
		for i in range(0,M0) :
			print 'calculating projection, (i,M0)='+str((i,M0))
			u=pg0.xsid(k0+i)
			b=[]
			for j in range(0,M1) :
				f=pg1.xsid(k1+j)
				if( f.support().intersect(u.support()).intersect(I).len()>0 ) :
					b.append([(f*u).integral(I)])
				else :
					b.append([decimal.Decimal(0)])
			b=numpy.matrix(b)
			c=GrammInv*b
			a.append([c[j,0] for j in range(0,M1)])
			r=poly.PiecewisePoly()
			for j in range(0,M1) :
				r+=pg1.xsid(k1+j)*c[j,0]
			dst=dist(u,r,I)
			print dst
			L2.append(dst)
		r={}
		r['Gramm']=Gramm
		r['GrammInv']=GrammInv
		r['indexes0']=indexes0
		r['indexes1']=indexes1
		r['L2']=L2
		r['scale matrix']=a
		r['d0']=pg0._d
		r['d1']=pg1._d
		return r
			