execfile('common.py')

import gram
import ots.io as io

name='blackDp.py'

version="A"
execfile('version_'+version+'.py')
gramFile='gram_version_'+version
basisFile='dirichlet3a_step'+str(steps)+'_d45_crN'+str(crN)+'_maxD'+str(maxD)+'_result'
gridFile='grid_version_'+version

try :
	multiBasis
except :
	multiBasis=load(basisFile)

def _check(cond,msg) :
	if( not cond ) :
		raise(Exception(msg))
		
def _m(a) :
	import numpy
	return numpy.matrix(a)

class BlackEquation(object) :
	def __init__(self,x0,t,T,sigma,precision) :
		self.x0=x0
		self.t=t
		self.T=T
		self.sigma=sigma
		self.precision=precision
		self.minimalNumberOfK=16
		self.minimalD=-7
	def calcInterval(self) :
		import scipy.stats
		import numpy
		N01Inv=scipy.stats.norm(0,1).ppf
		xsi0=abs(N01Inv(self.precision/2))
		sigma=self.sigma
		dt=self.T-self.t
		x1=numpy.exp(sigma*xsi0*numpy.sqrt(dt))
		x2=numpy.exp(-0.5*sigma*sigma*dt)
		x0=self.x0
		d0=self.minimalD
		while(True) :
			kA=int(numpy.floor(poly.pow2_(d0)*x0*x2/x1))
			kB=int(numpy.ceil(poly.pow2_(d0)*x0*x2*x1))
			kk=kB-kA+1
			if( kk>=self.minimalNumberOfK ) :
				break
			d0+=1
		self.int_d0=d0
		self.int_kA=kA
		self.int_kB=kB
	
def pm(x) :
	import ots.r_com
	ots.r_com.r.plotMatrix(_m(x))
def diag(x) :
	import numpy as np
	return _m(np.diag(np.diag(_m(x))))
def diagSqrt(x) :
	import numpy as np
	d=np.diag(_m(x))
	return _m(np.diag([np.sqrt(dd) for dd in d]))
def cn(x) :
	import ltools
	return ltools.condN(_m(x))
def unit(len) :
	import numpy as np
	return _m(np.diag([1 for x in range(0,len)]))

black=BlackEquation(x0=x0,t=t,T=T,sigma=sigma,precision=precision)
black.calcInterval()		
		
xsi=multiBasis['xsi']
chi=multiBasis[xsi.d]
msb=gram.MultiScaleBasis(xsi,chi,black.int_d0,black.int_kA,black.int_kB)
		
I=poly.Piece(msb.d,msb.kA,msb.kB)

strikeD=poly.pow2_(I.d())*strike
_check(strikeD-int(strikeD)==0,"strikeD is not int")
strikeD=int(strikeD)
payoff=poly.extend(poly.Piece(I.d(),strikeD,I.b()),[-strike,1])
u=poly.extend(I,[-I.xA(),1])*((I.xB()-strike)/(I.xB()-I.xA()))
payoff=poly.LPoly(payoff-u)
pp(payoff)

try :
	gm
except :
	print 'loading gram file'
	gm=load(gramFile)	
	print 'loaded gram file'
	gm.afterPickle()

grid=load(gridFile)

def sortGrid(g) :
	minScale=1000000
	for x in g :
		try :
			int(x[0])
		except :
			continue
		minScale=min(minScale,x[0])
	r=[]
	for x in g :
		scale=x[0]
		location=x[1]
		try :
			int(scale)
		except :
			scale=minScale
		r.append((location*1.0/pow(2,scale),x[0],x[1]))
	r.sort()
	return [(x[1],x[2]) for x in r]

grid2=sortGrid(grid)
dt=0.1

cnp1=gm.projection2(payoff,grid2)
#x1=black.oneTimeStep(tnp1=T,tn=T-dt,cnp1=cnp1[1],Knp1=grid2,Kn=grid2,gram=gm,d=20)
tnp1=T
tn=T-dt
cnp1=cnp1[1]
Knp1=grid2
Kn=grid2
gram=gm
d=20

import numpy as np
import scipy.linalg as la
dt=tnp1-tn
sigma=black.sigma
Gnp1=_m(gram.gram2(Kn,Knp1))
G=_m(gram.gram(Kn))
GI=G.I
Q=_m(gram.bgram(Kn))
dd=pow(2,d)
I=unit(len(Kn))
U=0.5*sigma*sigma*GI*Q.T

def makeH(dt,U,a=1) :
	import numpy as np
	U=dt*U
	I=unit(U.shape[0])
	dkk=[min(1,1/(1+x)) for x in np.diag(U)]
	D=a*_m(np.diag(dkk))
	H=D-I+D*U
	return H
	
def makeH2(dt,U) :
	import numpy as np
	U=dt*U
	N=U.shape[0]
	I=unit(N)
	sumUk=[]
	for k in range(0,N) :
		sum=0
		for s in range(0,N) :
			sum+=pow(U[k,s],2)
		sumUk.append(sum)
	Dk=[]
	for k in range(0,N) :
		x=(1+U[k,k])/(1+2*U[k,k]+sumUk)
		Dk.append(x)
	D=diag(Dk)
	H=D-I+D*U
	return H
	
		
	
	
HH=[makeH(dt=x,U=U) for x in [1,0.5,0.1,0.01]]
norms2=[la.norm(x,2) for x in HH]
normsFro=[la.norm(x,'fro') for x in HH]
print norms2
print normsFro

HH2=[makeH2(dt=x,U=U) for x in [1,0.5,0.1,0.01]]
norms2=[la.norm(x,2) for x in HH2]
normsFro=[la.norm(x,'fro') for x in HH2]
print norms2
print normsFro

print "frob U "+str(la.norm(U,'fro'))
print "sing val U "+str(ltools.maximalSingularValue(U))
print "spec rad U "+str(ltools.spectralRadius(U))

H=makeH2(dt=1,U=U)
print "frob H "+str(la.norm(H,'fro'))
print "sing val H "+str(ltools.maximalSingularValue(H))
print "spec rad H "+str(ltools.spectralRadius(H))

H=makeH2(dt=0.1,U=U)
print "frob H "+str(la.norm(H,'fro'))
print "sing val H "+str(ltools.maximalSingularValue(H))
print "spec rad H "+str(ltools.spectralRadius(H))

H=makeH2(dt=10.0,U=U)
print "frob H "+str(la.norm(H,'fro'))
print "sing val H "+str(ltools.maximalSingularValue(H))
print "spec rad H "+str(ltools.spectralRadius(H))

H=makeH2(dt=100.0,U=U)
print "frob H "+str(la.norm(H,'fro'))
print "sing val H "+str(ltools.maximalSingularValue(H))
print "spec rad H "+str(ltools.spectralRadius(H))


print "making another preconditioner"
H=makeH(dt=1,U=U)
print "frob H "+str(la.norm(H,'fro'))
print "sing val H "+str(ltools.maximalSingularValue(H))
print "spec rad H "+str(ltools.spectralRadius(H))

H=makeH(dt=0.1,U=U)
print "frob H "+str(la.norm(H,'fro'))
print "sing val H "+str(ltools.maximalSingularValue(H))
print "spec rad H "+str(ltools.spectralRadius(H))

H=makeH2(dt=1,U=U)

def makeLambda(V) :
	N=V.shape[0]
	a=[]
	for k in range(0,N) :
		aa=[]
		a.append(aa)
		for p in range(0,N) :
			if( k==p ) :
				x=2*pow(1+V[k,k],2)
			else :
				x=pow(V[k,p],2)+pow(V[p,k],2)
			aa.append(x)
	return _m(a)
	
V=H.T+H+H.T*H
L=makeLambda(V)

CNs=[cn(I-pow(H,int(pow(2,d)))) for d in range(1,10)]
print "condition numbers"
print CNs
SVs=[ltools.maximalSingularValue(pow(H,int(pow(2,d)))) for d in range(1,10)]
print "singular values"
print SVs
FROs=[la.norm(pow(H,int(pow(2,d))),'fro') for d in range(1,12)]
print "Frobenius norms"
print FROs

