execfile('common.py')

import gram
import ots.io as io

version="A"
execfile('version_'+version+'.py')
basisFile='dirichlet3a_step'+str(steps)+'_d45_crN'+str(crN)+'_maxD'+str(maxD)+'_result'
gramFile='gram_version_'+version
gridFile='grid_version_'+version

multiBasis=load(basisFile)

def _check(cond,msg) :
	if( not cond ) :
		raise(Exception(msg))

class BlackEquation(object) :
	def __init__(self,x0,t,T,sigma,precision) :
		self.x0=x0
		self.t=t
		self.T=T
		self.sigma=sigma
		self.precision=precision
		self.minimalNumberOfK=16
		self.minimalD=-7
	def calcInterval(self) :
		import scipy.stats
		import numpy
		N01Inv=scipy.stats.norm(0,1).ppf
		xsi0=abs(N01Inv(self.precision/2))
		sigma=self.sigma
		dt=self.T-self.t
		x1=numpy.exp(sigma*xsi0*numpy.sqrt(dt))
		x2=numpy.exp(-0.5*sigma*sigma*dt)
		x0=self.x0
		d0=self.minimalD
		while(True) :
			kA=int(numpy.floor(poly.pow2_(d0)*x0*x2/x1))
			kB=int(numpy.ceil(poly.pow2_(d0)*x0*x2*x1))
			kk=kB-kA+1
			if( kk>=self.minimalNumberOfK ) :
				break
			d0+=1
		self.int_d0=d0
		self.int_kA=kA
		self.int_kB=kB
		
	
		

black=BlackEquation(x0=x0,t=t,T=T,sigma=sigma,precision=precision)
black.calcInterval()		
		
xsi=multiBasis['xsi']
chi=multiBasis[xsi.d]
msb=gram.MultiScaleBasis(xsi,chi,black.int_d0,black.int_kA,black.int_kB)
		
I=poly.Piece(msb.d,msb.kA,msb.kB)

strikeD=poly.pow2_(I.d())*strike
_check(strikeD-int(strikeD)==0,"strikeD is not int")
strikeD=int(strikeD)
payoff=poly.extend(poly.Piece(I.d(),strikeD,I.b()),[-strike,1])
u=poly.extend(I,[-I.xA(),1])*((I.xB()-strike)/(I.xB()-I.xA()))
payoff=poly.LPoly(payoff-u)
pp(payoff)

try :
	gm
except :
	gm=load(gramFile)	
	gm.afterPickle()
grid=gm.bestGrid(payoff,gridPrecision,x0)

save(grid,gridFile)
