import sys
import PiecewisePoly as poly
import time
import numpy
import numpy as np
import ots.r_com as r_com
r=r_com.r
import ots.math_com as math_com
m=math_com.m
import tools
import ltools
import scipy.linalg as la

f1=poly.Poly([1,-1,1,0],[[1],[1]])
f2=poly.Poly([0,-1,1,1],[[1,1],[1,-1]])

def plotPoly(func,N=10000,x0=None,x1=None) :
	"Plot a PiecewisePoly.Poly-nomial via r_com"
	spt=func.support()
	scale=pow(2,spt.d())
	if( x0 is None ) :
		x0=(1.0*spt.a())/scale
	if( x1 is None ):
		x1=(1.0*spt.b())/scale
	h=(x1-x0)*1.0/N
	x=[x0+i*h for i in range(0,N+1)]
	y=func.batch(x)
	r_com.r.set('x',x)
	r_com.r.set('y',y)
	r_com.r.plot(r_com.r('x'),r_com.r('y'))
pp=plotPoly
	
saveDir='c:\\otsprojects\\python\\wavelet2\\data\\'
def save(obj,fileName) :
	import ots.io as io
	io.save(obj,fileName,saveDir)
def load(fileName) :
	import ots.io as io
	return io.load(fileName,saveDir)
def getSaveFile(fileName) :
	import ots.io as io
	return io.getSaveFile(fileName,saveDir)

def _check(cond,msg) :
	if( not cond ) :
		raise(Exception(msg))
def _m(a) :
	import numpy
	return numpy.matrix(a)
def pm(x) :
	import ots.r_com
	ots.r_com.r.plotMatrix(_m(x))
def diag(x) :
	import numpy as np
	return _m(np.diag(np.diag(_m(x))))
def diagSqrt(x) :
	import numpy as np
	d=np.diag(_m(x))
	return _m(np.diag([np.sqrt(dd) for dd in d]))
def cn(x) :
	import ltools
	return ltools.condN(_m(x))
def unit(len) :
	import numpy as np
	return _m(np.diag([1 for x in range(0,len)]))
def uniqueUnion(X,Y) :
	Z=X+Y
	Z.sort()
	prev=None
	r=[]
	for x in Z :
		if( x==prev ) :
			continue
		prev=x
		r.append(x)
	return r
def takeElement(c,i) :
	import numpy as np
	if( type(c)==type([]) ) :
		return c[i]
	if( type(c)==np.matrix ) :
		try :
			return c[i,0]
		except :
			pass
		try :
			return c[0,i]
		except :
			pass
	raise(Exception("takeElement failed"))
def makeFunc(grid,gram,c) :
	r=poly.LZero(gram.func(grid[0]).support())
	_check(len(c)==len(grid),"Size mismatch")
	for i in range(0,len(c)) :
		r+=gram.func(grid[i])*takeElement(c,i)
	return r
	
	