import PiecewisePoly as poly2
import ltools
import pdb

def Getter1(Self,attr,k) :
	try :
		if( getattr(Self,attr) is None ) :
			setattr(Self,attr,{})
	except :
		setattr(Self,attr,{})
	a=getattr(Self,attr)
	if( not a[k] is None ) :
		return a[k]
	else :
		raise(Exception("exit from Getter1"))
def Getter2(Self,attr,m,k) :
	try :
		if( getattr(Self,attr) is None ) :
			setattr(Self,attr,{})
	except :
		setattr(Self,attr,{})
	a=getattr(Self,attr)
	try :
		if( a[m] is None ) :
			a[m]={}
	except :
		a[m]={}
	if(not a[m][k] is None ) :
		return a[m][k]
	else :
		raise(Exception("exit from Getter2"))
	
	
class PhiGenerator(object) :
	"""
	Source of phi/Phi-basis on [0,1] with Dirichlet boundary conditions.
	"""
	maximalSupport=poly2.Piece(0,-100,100)
	def __init__(self) :
		"""
			Constructed class must execute
			init* to be operational.
		"""
		pass
	def xPower(self,m) :
		try :
			return Getter1(self,'_xPower',m)
		except :
			pass
		print 'xPower, m='+str(m)
		kI=self._kI
		N=self._n
		kL=kI[0]-1
		kR=kI[-1]+1
		I=poly2.Piece(0,0,1)
		if( 0<m and m<N ) :
			x=poly2.LPoly(poly2.extend(PhiGenerator.maximalSupport,[0,1]))
			x=x.pow(m)
			f=[]
			for k in range(m+1,N) :
				f.append(self.xPower_(k))
			for i in range(0,N) :
				f.append(self.phi_(kI[i]))
			proj=ltools.projection2(x,f,I)[0]
			df=x-proj
			L2=ltools.l2Norm(df,I)
			print 'xPower, L2='+str(L2)
			df=df*(1.0/L2)
			self._xPower[m]=ltools.polyToDescription(df)
			return self._xPower[m]
		raise(Exception('Wrong index m'))
	def xPower_(self,m) :
		return ltools.descriptionToPoly(self.xPower(m))
	def x1Power(self,m) :
		try :
			return Getter1(self,'_x1Power',m)
		except :
			pass
		print 'x1Power, m='+str(m)
		kI=self._kI
		N=self._n
		kL=kI[0]-1
		kR=kI[-1]+1
		I=poly2.Piece(0,0,1)
		if( 0<m and m<N ) :
			x=poly2.LPoly(poly2.extend(PhiGenerator.maximalSupport,[1,-1]))
			x=x.pow(m)
			f=[]
			for k in range(m+1,N) :
				f.append(self.x1Power_(k))
			for i in range(0,N) :
				f.append(self.phi_(kI[len(kI)-1-i]))
			proj=ltools.projection2(x,f,I)[0]
			df=x-proj
			L2=ltools.l2Norm(df,I)
			print 'x1Power, L2='+str(L2)
			df=df*(1.0/L2)
			self._x1Power[m]=ltools.polyToDescription(df)
			return self._x1Power[m]
		raise(Exception('Wrong index m'))
	def x1Power_(self,m) :
		return ltools.descriptionToPoly(self.x1Power(m))
	def xsid(self,k0) :
		try :
			return Getter1(self,'_xsid',k0)
		except :
			pass
		print 'xsid, k0='+str(k0)
		kI=self._kI
		N=self._n-1
		kL=kI[0]-1
		kR=kI[-1]+1
		I=poly2.Piece(0,0,1)
		if( k0 in kI ) :
			return self.phi(k0)
		if( kL-N<k0 and k0<=kL ) :
			spt=self.etad_(kL).support()
			for i in range(0,N) :
				spt=spt.union(self.etad_(kL-i).support())
			f=[]
			for k in range(k0+1,kL+1) :
				f.append(self.xsid_(k))
			for k in kI :
				u=self.etad_(k)
				if( u.support().intersect(spt).len()>0 ) :
					f.append(u)
			u=self.etad_(k0)
			proj=ltools.projection2(u,f,I)[0]
			df=u-proj
			L2=ltools.l2Norm(df,I)
			print 'xsid, L2='+str(L2)
			df=df*(1.0/L2)
			self._xsid[k0]=ltools.polyToDescription(df)
			return self._xsid[k0]
		if( kR<=k0 and k0<kR+N ) :
			spt=self.etad_(kR).support()
			for i in range(0,N) :
				spt=spt.union(self.etad_(kR+i).support())
			f=[]
			for k in kI :
				u=self.etad_(k)
				if( u.support().intersect(spt).len()>0 ) :
					f.append(u)
			for k in range(kR,k0) :
				f.append(self.xsid_(k))
			u=self.etad_(k0)
			proj=ltools.projection2(u,f,I)[0]
			df=u-proj
			L2=ltools.l2Norm(df,I)
			print 'xsid, L2='+str(L2)
			df=df*(1.0/L2)
			self._xsid[k0]=ltools.polyToDescription(df)
			return self._xsid[k0]
		raise(Exception("Wrong k0 index in xsid"))
	def xsid_(self,k0) :
		return ltools.descriptionToPoly(self.xsid(k0))
	def etad(self,k) :
		try :
			return Getter1(self,'_etad',k)
		except :
			pass
		kI=self._kI
		N=self._n-1
		minK=kI[0]
		maxK=kI[-1]
		if( k in kI ) :
			return self.phi(k)
		if( minK-N<=k and k<=minK-1 ) :
			self._etad[k]=self.xmdL(N-minK+k+1)
		elif( maxK+1<=k and k<=maxK+N ) :
			self._etad[k]=self.x1mdR(N-k+maxK+1)
		else :
			raise(Exception("Wrong k index in etad"))
		return self._etad[k]		
	def etad_(self,k) :
		return ltools.descriptionToPoly(self.etad(k))
	def Etad(self,k) :
		try :
			return Getter1(self,'_Etad',k)
		except :
			pass
		KI=self._KI
		N=self._N-1
		minK=KI[0]
		maxK=KI[-1]
		if( k in KI ) :
			return self.Phi(k)
		if( minK-N<=k and k<=minK-1 ) :
			self._Etad[k]=self.XmdL(N-minK+k+1)
		elif( maxK+1<=k and k<=maxK+N ) :
			self._Etad[k]=self.X1mdR(N-k+maxK+1)
		else :
			raise(Exception("Wrong k index in Etad"))
		return self._Etad[k]		
	def Etad_(self,k) :
		return ltools.descriptionToPoly(self.Etad(k))
	def init7(self,phi,Phi,d,n,N,kernel1=None,kernel2=None) :
		"""
		Constructs generator of bounary polynomials.
		phi - the scaling function, description tuple.
		Phi - the tilde scaling function, description tuple.
		d - scale.
		n - number of vanishing moments for psi.
		N - number of vanishing moments for Psi.
		"""
		self._kernel1=kernel1
		self._kernel2=kernel2
		self._doInit(phi,Phi,d,n,N)
		if( self._kernel1 is None ) :
			print "default kernel1"
			self._kernel1=ltools.polyToDescription(
				ltools.descriptionToPoly(phi).Op(d,self._kI[0])
				)
		if( self._kernel2 is None ) :
			print "default kernel2"
			self._kernel2=ltools.polyToDescription(
				ltools.descriptionToPoly(phi).Op(d,self._kI[-1])
				)
	def init8(self,phi,psi,Phi,Psi,d,precision,kernel1=None,kernel2=None) :
		"""
		Constructs generator of bounary polynomials.
		phi - the scaling function, description tuple.
		Phi - the tilde scaling function, description tuple.
		d - scale.
		precision - the moment is considered vanishing if it is below this number.
		"""
		n=self._numberOfVanishingMoments(psi,precision)
		N=self._numberOfVanishingMoments(Psi,precision)
		self._kernel1=kernel1
		self._kernel2=kernel2
		self._doInit(phi,Phi,d,n,N)
		if( self._kernel1 is None ) :
			print "default kernel1"
			self._kernel1=ltools.polyToDescription(
				ltools.descriptionToPoly(phi).Op(d,self._kI[0])
				)
		if( self._kernel2 is None ) :
			print "default kernel2"
			self._kernel2=ltools.polyToDescription(
				ltools.descriptionToPoly(phi).Op(d,self._kI[-1])
				)
	def phi(self,k) :
		return ltools.polyToDescription(ltools.descriptionToPoly(self._phi).Op(self._d,k))
	def phi_(self,k) :
		return ltools.descriptionToPoly(self._phi).Op(self._d,k)
	def Phi(self,k) :
		return ltools.polyToDescription(ltools.descriptionToPoly(self._Phi).Op(self._d,k))
	def Phi_(self,k) :
		return ltools.descriptionToPoly(self._Phi).Op(self._d,k)
	def xmdk(self,m,k) :
		try :
			return Getter2(self,'_xmdk',m,k)
		except :
			pass
		self._xmdk[m][k]=ltools.Scalar(self.xPower_(m),self.phi_(k))
		return self._xmdk[m][k]
	def Xmdk(self,m,k) :
		try :
			return Getter2(self,'_Xmdk',m,k)
		except :
			pass
		self._Xmdk[m][k]=ltools.Scalar(self.xPower_(m),self.Phi_(k))
		return self._Xmdk[m][k]
	def x1mdk(self,m,k) :
		try :
			return Getter2(self,'_x1mdk',m,k)
		except :
			pass
		self._x1mdk[m][k]=ltools.Scalar(self.x1Power_(m),self.phi_(k))
		return self._x1mdk[m][k]
	def X1mdk(self,m,k) :
		try :
			return Getter2(self,'_X1mdk',m,k)
		except :
			pass
		self._X1mdk[m][k]=ltools.Scalar(self.x1Power_(m),self.Phi_(k))
		return self._X1mdk[m][k]
	def xmdL(self,m) :
		try :
			return Getter1(self,'_xmdL',m)
		except :
			pass
		r=poly2.LZero(poly2.Piece(0,0,1))
		for k in self._kL :
			r+=self.phi_(k)*self.Xmdk(m,k)
		self._xmdL[m]=ltools.polyToDescription(r)
		return self._xmdL[m]
	def xmdL_(self,m) :
		return ltools.descriptionToPoly(self.xmdL(m))
	def XmdL(self,m) :
		try :
			return Getter1(self,'_XmdL',m)
		except :
			pass
		r=poly2.LZero(poly2.Piece(0,0,1))
		for k in self._KL :
			r+=self.Phi_(k)*self.xmdk(m,k)
		self._XmdL[m]=ltools.polyToDescription(r)
		return self._XmdL[m]
	def XmdL_(self,m) :
		return ltools.descriptionToPoly(self.XmdL(m))
	def x1mdR(self,m) :
		try :
			return Getter1(self,'_x1mdR',m)
		except :
			pass
		r=poly2.LZero(poly2.Piece(0,0,1))
		for k in self._kR :
			r+=self.phi_(k)*self.X1mdk(m,k)
		self._x1mdR[m]=ltools.polyToDescription(r)
		return self._x1mdR[m]
	def x1mdR_(self,m) :
		return ltools.descriptionToPoly(self.x1mdR(m))
	def X1mdR(self,m) :
		try :
			return Getter1(self,'_X1mdR',m)
		except :
			pass
		r=poly2.LZero(poly2.Piece(0,0,1))
		for k in self._KR :
			r+=self.Phi_(k)*self.x1mdk(m,k)
		self._X1mdR[m]=ltools.polyToDescription(r)
		return self._X1mdR[m]
	def X1mdR_(self,m) :
		return ltools.descriptionToPoly(self.X1mdR(m))
	def _numberOfVanishingMoments(self,psi,precision) :
		"""
		Calculates the number of vanishing moments 
		and builds powers of x
		"""
		k=0
		psi=ltools.descriptionToPoly(psi)
		x=poly2.LPoly(poly2.extend(self.maximalSupport,[0,1]))
		while(True) :
			i=ltools.Scalar(x.pow(k),psi)
			print "moment "+str(k)+"="+str(i)
			if( float(abs(i))>precision ) :
				return k
			k+=1
	def _doInit(self,phi,Phi,d,n,N) :
		self._I=poly2.Piece(0,0,1)
		self._phi=phi
		self._Phi=Phi
		self._d=d
		self._n=n
		self._N=N
		r=Ksets(self._phi,self._d)
		self._k=r['K']
		self._kL=r['KL']
		self._kR=r['KR']
		self._kI=r['KI']
		if( len(self._kI)==0 ) :
			raise(Exception("Scale is too small"))
		r=Ksets(self._Phi,self._d)
		self._K=r['K']
		self._KL=r['KL']
		self._KR=r['KR']
		self._KI=r['KI']
		if( len(self._KI)==0 ) :
			raise(Exception("Scale is too small"))
		kk=range(self._kI[0]-self._n+1,self._kI[0])
		kk.extend(self._kI)
		kk.extend(range(self._kI[-1]+1,self._kI[-1]+self._n))
		self._kk=kk
		KK=range(self._KI[0]-self._n+1,self._KI[0])
		KK.extend(self._KI)
		KK.extend(range(self._KI[-1]+1,self._KI[-1]+self._n))
		self._KK=KK
	def __str__(self) :
		s="dirichlet.PhiGenerator(\n"
		s+="_d="+str(self._d)+'\n'
		s+="_n="+str(self._n)+'\n'
		s+="_N="+str(self._N)+'\n'
		s+="_k="+str(self._k)+'\n'
		s+="_kk="+str(self._kk)+'\n'
		s+="_kL="+str(self._kL)+'\n'
		s+="_kR="+str(self._kR)+'\n'
		s+="_kI="+str(self._kI)+'\n'
		s+="_K="+str(self._K)+'\n'
		s+="_KK="+str(self._KK)+'\n'
		s+="_KL="+str(self._KL)+'\n'
		s+="_KR="+str(self._KR)+'\n'
		s+="_KI="+str(self._KI)+'\n'
		s+=")\n"
		return s
	def __repr__(self) :
		return self.__str__()
	def makeDp1(self) :
		r=PhiGenerator()
		r.init7(
			phi=self._phi,
			Phi=self._Phi,
			d=self._d+1,
			n=self._n,
			N=self._N
		)
		r._xsid={}
		#find k_d on left
		maxK0=self._kL[-1]
		maxK1=r._kL[-1]
		phi=ltools.descriptionToPoly(self._phi)
		r_phi=ltools.descriptionToPoly(r._phi)
		spt0=phi.support().Op(self._d,maxK0)
		spt1=r_phi.support().Op(r._d,maxK1)
		diff=10
		kD=-1000
		for k in range(0,len(r._kI)+2*len(r._kL)+1) :
			sptA=spt0.Op(1,k)
			d=numpy.abs(sptA.xB()-spt1.xB())
			if( d<diff ) :
				diff=d
				kD=k
			sptA=spt0.Op(1,-k)
			d=numpy.abs(sptA.xB()-spt1.xB())
			if( d<diff ) :
				diff=d
				kD=-k
		kL=kD
		print 'kL='+str(kL)
		#find k_d on right
		minK0=self._kR[0]
		minK1=r._kR[0]
		spt0=phi.support().Op(self._d,minK0)
		spt1=r_phi.support().Op(r._d,minK1)
		diff=10
		kD=-1000
		for k in range(0,len(r._kI)+2*len(r._kL)+1) :
			sptA=spt0.Op(1,k)
			d=numpy.abs(sptA.xB()-spt1.xB())
			if( d<diff ) :
				diff=d
				kD=k
			sptA=spt0.Op(1,-k)
			d=numpy.abs(sptA.xB()-spt1.xB())
			if( d<diff ) :
				diff=d
				kD=-k
		kR=kD	
		print 'kR='+str(kR)
		for i in range(0,self._N-1) :
			print i
			r._xsid[r._kI[0]-1-i]=ltools.polyToDescription(
				self.xsid_(self._kI[0]-1-i).Op(1,kL)
				)
			r._xsid[r._kI[-1]+1+i]=ltools.polyToDescription(
				self.xsid_(self._kI[-1]+1+i).Op(1,kR)
				)
		return r
	def clearIntermediateData(self) :
		try :
			del self._xPower
		except :
			pass
		try :
			del self._x1Power
		except :
			pass
		try :
			del self._xmdL
		except :
			pass
		try :
			del self._x1mdR
		except :
			pass
		try :
			del self._etad
		except :
			pass
		try :
			del self._I
		except :
			pass

def closestInt(x) :
	iB=numpy.ceil(x)
	iA=numpy.floor(x)
	if( abs(x-iA)>abs(x-iB) ) :
		return int(iB)
	return int(iA)
def adjSpt(f) :
	"""
	Adjusted support: sometimes scaling function comes out
	of scaling procedure with slightly non-integer support bounds.
	This function returns the corrected support.
	"""
	if(type(f)==type(poly2.LPoly())) :
		s=f.support()
	elif(type(f)==type(poly2.Piece())) :
		s=f
	else :
		raise(Exception("Wrong type"))
	return poly2.Piece(0,closestInt(s.xA()),closestInt(s.xB()))
def Ksets(phi,d) :
	"""
	Calculate the sets K_d,K_{d,L},K_{d,I},K_{d,L}.
	See the Notes.
	phi is the scaling function.
	d is the scale.
	"""
	phi=ltools.descriptionToPoly(phi)
	spt=adjSpt(phi)
	I01=poly2.Piece(0,0,1)
	#starting point
	k=0
	while(True) :
		if(spt.Op(d,k).intersect(I01).len()>0) :
			k0=k
			break
		if(spt.Op(d,-k).intersect(I01).len()>0) :
			k0=-k
			break
		k+=1
	#K
	k=k0
	while(True) :
		if(spt.Op(d,k).intersect(I01).len()<=0) :
			break
		k=k-1
	Ka=k+1
	k=k0
	while(True) :
		if(spt.Op(d,k).intersect(I01).len()<=0) :
			break
		k=k+1
	Kb=k-1
	K=range(Ka,Kb+1)
	#K_L,K_R
	k=K[0]
	while(True) :
		if( not spt.Op(d,k).inside(0) ) :
			break
		k=k+1
	KL=range(K[0],k)
	k=K[-1]
	while(True) :
		if( not spt.Op(d,k).inside(1) ) :
			break
		k=k-1
	KR=range(k+1,K[-1]+1)
	#K_I
	KI=range(KL[-1]+1,KR[0])
	#check internal supports
	if( len(KI)==0 ) :
		raise(Exception("d is too small"))
	return {'K':K,'KL':KL,'KR':KR,'KI':KI}
	
def polynomialTest(phiGen) :
	N=phiGen._n
	I=poly2.Piece(0,0,1)
	f=[]
	for k in phiGen._kk :
		f.append(phiGen.xsid_(k))
	A=ltools.grammMatrix(f,I)
	cn=ltools.condN(A)
	print 'condition number='+str(cn)
	AInv=A.I
	r={}
	r['condN']=cn
	for i in range(0,N) :
		x=poly2.LPoly(poly2.extend(I,[0,1]))
		if(i<=1) :
			x=x.pow(i)
		else :
			xx=poly2.LPoly(poly2.extend(I,[0,1,-1]))
			x=x.pow(i-2).mult(xx)
		proj=ltools.projection3(u=x,f=f,grammInv=AInv,I=I)[0]
		df=x-proj
		L2=ltools.l2Norm(df,I)
		print 'L2='+str(L2)
		r[i]=L2
	return r
	
def scaling(phiGen0,phiGen1) :
	I=poly2.Piece(0,0,1)
	r={}
	r['d0']=phiGen0._d
	r['d1']=phiGen1._d
	f=[]
	for k in phiGen1._kk :
		f.append(phiGen1.xsid_(k))
	A=ltools.grammMatrix(f,I)
	print 'condN='+str(ltools.condN(A))
	r['A']=A
	AInv=A.I
	sc=[]
	L2list=[]
	DL2list=[]
	for k in phiGen0._kk :
		print 'scaling, k='+str(k)
		u=phiGen0.xsid_(k)
		(proj,scale)=ltools.projection3(u=u,f=f,grammInv=AInv,I=I)
		sc.append(scale)
		df=u-proj
		L2=ltools.l2Norm(df,I)
		print 'L2='+str(L2)
		L2list.append(L2)
		DL2=ltools.l2Norm(df.D(),I)
		print 'DL2='+str(DL2)
		DL2list.append(DL2)
	r['scale']=sc
	r['L2']=L2list
	r['DL2']=DL2list
	return r


	
class PhiGenerator2(object) :
	"""
	Source of phi-basis on [0,1].
	"""
	maximalSupportSize=256
	searchLimit=25
	def __init__(self) :
		"""
			Constructed class must execute
			init* to be operational.
		"""
		pass
	def xPower(self,m) :
		try :
			return Getter1(self,'_xPower',m)
		except :
			pass
		print 'xPower, m='+str(m)
		kI=self._kI
		N=self._n
		kL=kI[0]-1
		kR=kI[-1]+1
		I=poly2.Piece(0,0,1)
		S=self.maximalSupportSize
		SS=int(1.0*S*self._n/pow(2.0,self._d))+1
		if( 0<m and m<N ) :
			x=poly2.LPoly(poly2.extend(poly2.Piece(0,-SS,SS),[0,1]))
			x=x.pow(m)
			f=[]
			for k in range(m+1,N) :
				f.append(self.xPower_(k))
			for i in range(0,N) :
				f.append(self.phi_(kI[i]))
			proj=ltools.projection2(x,f,I)[0]
			df=x-proj
			L2=ltools.l2Norm(df,I)
			print 'xPower, L2='+str(L2)
			df=df*(1.0/L2)
			self._xPower[m]=ltools.polyToDescription(df)
			return self._xPower[m]
		raise(Exception('Wrong index m'))
	def xPower_(self,m) :
		return ltools.descriptionToPoly(self.xPower(m))
	def x1Power(self,m) :
		try :
			return Getter1(self,'_x1Power',m)
		except :
			pass
		print 'x1Power, m='+str(m)
		kI=self._kI
		N=self._n
		kL=kI[0]-1
		kR=kI[-1]+1
		I=poly2.Piece(0,0,1)
		S=self.maximalSupportSize
		SS=int(1.0*S*self._n/pow(2.0,self._d))+1
		if( 0<m and m<N ) :
			x=poly2.LPoly(poly2.extend(poly2.Piece(0,-SS,SS),[1,-1]))
			x=x.pow(m)
			f=[]
			for k in range(m+1,N) :
				f.append(self.x1Power_(k))
			for i in range(0,N) :
				f.append(self.phi_(kI[len(kI)-1-i]))
			proj=ltools.projection2(x,f,I)[0]
			df=x-proj
			L2=ltools.l2Norm(df,I)
			print 'x1Power, L2='+str(L2)
			df=df*(1.0/L2)
			self._x1Power[m]=ltools.polyToDescription(df)
			return self._x1Power[m]
		raise(Exception('Wrong index m'))
	def x1Power_(self,m) :
		return ltools.descriptionToPoly(self.x1Power(m))
	def xsid(self,k0) :
		try :
			return Getter1(self,'_xsid',k0)
		except :
			pass
		print 'xsid, k0='+str(k0)
		kI=self._kI
		N=self._n-1
		kL=kI[0]-1
		kR=kI[-1]+1
		I=poly2.Piece(0,0,1)
		if( k0 in kI ) :
			return self.phi(k0)
		if( kL-N<k0 and k0<=kL ) :
			spt=self.etad_(kL).support()
			for i in range(0,N) :
				spt=spt.union(self.etad_(kL-i).support())
			f=[]
			for k in range(k0+1,kL+1) :
				f.append(self.xsid_(k))
			for k in kI :
				u=self.etad_(k)
				if( u.support().intersect(spt).len()>0 ) :
					f.append(u)
			u=self.etad_(k0)
			proj=ltools.projection2(u,f,I)[0]
			df=u-proj
			L2=ltools.l2Norm(df,I)
			print 'xsid, L2='+str(L2)
			df=df*(1.0/L2)
			self._xsid[k0]=ltools.polyToDescription(df.segment(self._I))
			return self._xsid[k0]
		if( kR<=k0 and k0<kR+N ) :
			spt=self.etad_(kR).support()
			for i in range(0,N) :
				spt=spt.union(self.etad_(kR+i).support())
			f=[]
			for k in kI :
				u=self.etad_(k)
				if( u.support().intersect(spt).len()>0 ) :
					f.append(u)
			for k in range(kR,k0) :
				f.append(self.xsid_(k))
			u=self.etad_(k0)
			proj=ltools.projection2(u,f,I)[0]
			df=u-proj
			L2=ltools.l2Norm(df,I)
			print 'xsid, L2='+str(L2)
			df=df*(1.0/L2)
			self._xsid[k0]=ltools.polyToDescription(df)
			return self._xsid[k0]
		raise(Exception("Wrong k0 index in xsid"))
	def xsid_(self,k0) :
		return ltools.descriptionToPoly(self.xsid(k0))
	def etad(self,k) :
		try :
			return Getter1(self,'_etad',k)
		except :
			pass
		kI=self._kI
		N=self._n-1
		minK=kI[0]
		maxK=kI[-1]
		if( k in kI ) :
			return self.phi(k)
		if( minK-N<=k and k<=minK-1 ) :
			self._etad[k]=self.xmdL(N-minK+k+1)
		elif( maxK+1<=k and k<=maxK+N ) :
			self._etad[k]=self.x1mdR(N-k+maxK+1)
		else :
			raise(Exception("Wrong k index in etad"))
		return self._etad[k]		
	def etad_(self,k) :
		return ltools.descriptionToPoly(self.etad(k))
	def init3(self,phi,d,n) :
		"""
		Constructs generator of bounary polynomials.
		phi - the scaling function, description tuple.
		d - scale.
		n - number of vanishing moments for psi.
		"""
		self._doInit(phi,d,n)
	def init4(self,phi,psi,d,precision) :
		"""
		Constructs generator of bounary polynomials.
		phi - the scaling function, description tuple.
		Phi - the tilde scaling function, description tuple.
		d - scale.
		precision - the moment is considered vanishing if it is below this number.
		"""
		n=self._numberOfVanishingMoments(psi,precision)
		self._doInit(phi,d,n)
	def phi(self,k) :
		return ltools.polyToDescription(ltools.descriptionToPoly(self._phi).Op(self._d,k))
	def phi_(self,k) :
		return ltools.descriptionToPoly(self._phi).Op(self._d,k)
	def pNormSearch(self,p) :
		M1=2*self._n
		M2=4*self._n
		r1=self.pNorm(M1,p)
		r2=self.pNorm(M2,p)
		while(True) :
			M3=M2*2
			r3=self.pNorm(M3,p)
			print 'pass 1, M1,M2,M3='+str((M1,M2,M3))+' L2='+str((r1['L2'],r2['L2'],r3['L2']))
			if( r3['L2']>r2['L2'] ) :
				break
			if( M3>self._n*self.searchLimit ) :
				return (M3,r3)
			M1=M2
			M2=M3
			r1=r2
			r2=r3
		while(True) :
			M3=int((M1+M2)*0.5)
			if( M3==M1 or M3==M2 ) :
				break
			r3=self.pNorm(M3,p)
			print 'pass 2, M1,M2,M3='+str((M1,M2,M3))+' L2='+str((r1['L2'],r2['L2'],r3['L2']))
			if( r3['L2']<r1['L2'] ) :
				r1=r3
				M1=M3
			else :
				r2=r3
				M2=M3
		return (M1,r1)
	def pNorm(self,M,p) :
		f=[]
		for k in range(-M,M+2) :
			f.append(self.phi_(k))
		r=ltools.Projection2(u=p,f=f)
		return {'L2':ltools.l2Norm(p-r[0],self._I), 'c':r[1]}
	def xmdL(self,m) :
		try :
			return Getter1(self,'_xmdL',m)
		except :
			pass
		p=self.xPower_(m)
		pn=self.pNormSearch(p)
		M=pn[0]
		c=pn[1]['c']
		r=poly2.LZero(poly2.Piece(0,0,1))
		for k in self._kL :
			r+=self.phi_(k)*c[k+M]
		self._xmdL[m]=ltools.polyToDescription(r.segment(self._I))
		return self._xmdL[m]
	def xmdL_(self,m) :
		return ltools.descriptionToPoly(self.xmdL(m))
	def x1mdR(self,m) :
		try :
			return Getter1(self,'_x1mdR',m)
		except :
			pass
		p=self.x1Power_(m)
		pn=self.pNormSearch(p)
		M=pn[0]
		c=pn[1]['c']
		r=poly2.LZero(poly2.Piece(0,0,1))
		for k in self._kR :
			r+=self.phi_(k)*c[k+M]
		self._x1mdR[m]=ltools.polyToDescription(r.segment(self._I))
		return self._x1mdR[m]
	def x1mdR_(self,m) :
		return ltools.descriptionToPoly(self.x1mdR(m))
	def _numberOfVanishingMoments(self,psi,precision) :
		"""
		Calculates the number of vanishing moments 
		and builds powers of x
		"""
		k=0
		psi=ltools.descriptionToPoly(psi)
		x=poly2.LPoly(poly2.extend(poly2.Piece(0,-100,100),[0,1]))
		while(True) :
			i=ltools.Scalar(x.pow(k),psi)
			print "moment "+str(k)+"="+str(i)
			if( float(abs(i))>precision ) :
				return k
			k+=1
	def _doInit(self,phi,d,n) :
		self._I=poly2.Piece(0,0,1)
		self._phi=phi
		self._d=d
		self._n=n
		r=Ksets(self._phi,self._d)
		self._k=r['K']
		self._kL=r['KL']
		self._kR=r['KR']
		self._kI=r['KI']
		if( len(self._kI)==0 ) :
			raise(Exception("Scale is too small"))
		kk=range(self._kI[0]-self._n+1,self._kI[0])
		kk.extend(self._kI)
		kk.extend(range(self._kI[-1]+1,self._kI[-1]+self._n))
		self._kk=kk
	def __str__(self) :
		s="PhiGenerator(\n"
		s+="_d="+str(self._d)+'\n'
		s+="_n="+str(self._n)+'\n'
		s+="_k="+str(self._k)+'\n'
		s+="_kk="+str(self._kk)+'\n'
		s+="_kL="+str(self._kL)+'\n'
		s+="_kR="+str(self._kR)+'\n'
		s+="_kI="+str(self._kI)+'\n'
		s+=")\n"
		return s
	def __repr__(self) :
		return self.__str__()
	def makeDp1(self) :
		r=PhiGenerator2()
		r.init3(
			phi=self._phi,
			d=self._d+1,
			n=self._n
		)
		r._xsid={}
		#find k_d on left
		maxK0=self._kL[-1]
		maxK1=r._kL[-1]
		phi=ltools.descriptionToPoly(self._phi)
		r_phi=ltools.descriptionToPoly(r._phi)
		spt0=phi.support().Op(self._d,maxK0)
		spt1=r_phi.support().Op(r._d,maxK1)
		diff=10
		kD=-1000
		for k in range(0,len(r._kI)+2*len(r._kL)+1) :
			sptA=spt0.Op(1,k)
			d=numpy.abs(sptA.xB()-spt1.xB())
			if( d<diff ) :
				diff=d
				kD=k
			sptA=spt0.Op(1,-k)
			d=numpy.abs(sptA.xB()-spt1.xB())
			if( d<diff ) :
				diff=d
				kD=-k
		kL=kD
		print 'kL='+str(kL)
		#find k_d on right
		minK0=self._kR[0]
		minK1=r._kR[0]
		spt0=phi.support().Op(self._d,minK0)
		spt1=r_phi.support().Op(r._d,minK1)
		diff=10
		kD=-1000
		for k in range(0,len(r._kI)+2*len(r._kL)+1) :
			sptA=spt0.Op(1,k)
			d=numpy.abs(sptA.xB()-spt1.xB())
			if( d<diff ) :
				diff=d
				kD=k
			sptA=spt0.Op(1,-k)
			d=numpy.abs(sptA.xB()-spt1.xB())
			if( d<diff ) :
				diff=d
				kD=-k
		kR=kD	
		print 'kR='+str(kR)
		for i in range(0,self._n-1) :
			print i
			r._xsid[r._kI[0]-1-i]=ltools.polyToDescription(
				self.xsid_(self._kI[0]-1-i).Op(1,kL)
				)
			r._xsid[r._kI[-1]+1+i]=ltools.polyToDescription(
				self.xsid_(self._kI[-1]+1+i).Op(1,kR)
				)
		return r
	def clearIntermediateData(self) :
		try :
			del self._xPower
		except :
			pass
		try :
			del self._x1Power
		except :
			pass
		try :
			del self._etad
		except :
			pass
		try :
			del self._I
		except :
			pass

