class MRGram(object) :
	def __init__(self,gram,interval) :
		import PiecewisePoly as poly
		self._gram=gram
		self.one=poly.LPoly(poly.extend(interval,[1]))
		self.x=poly.LPoly(poly.extend(interval,[0,1]))
		self.x2=self.x.mult(self.x)
		self._P={}
		self._R={}
		self._Q={}
		self.silent=True
	def beforePickle(self) :
		one=self.one
		self._gram=None
		self.one=None
		self.x=None
		self.x2=None
		self.d=one.support().d()
		self.a=one.support().a()
		self.b=one.support().b()
	def afterPickle(self,gram) :
		import PiecewisePoly as poly
		interval=poly.Piece(self.d,self.a,self.b)
		self._gram=gram
		self.one=poly.LPoly(poly.extend(interval,[1]))
		self.x=poly.LPoly(poly.extend(interval,[0,1]))
		self.x2=self.x.mult(self.x)
		self.silent=True
	def _makeGram(self,grid,op) :
		r=[]
		for id1 in grid :
			rr=[]
			r.append(rr)
			for id2 in grid :
				rr.append(op(id1,id2))
		return r
	def _p(self,id1,id2) :
		if( not self.silent ) :
			print "_p("+str(id1)+","+str(id2)+")"
		u1=self._gram.func(id1).D()
		u2=self._gram.func(id2)
		return u1.mult(self.x).mult(u2).integral()
	def evalP(self,id1,id2) :
		try :
			return self._P[(id1,id2)]
		except :
			r=self._p(id1,id2)
			self._P[(id1,id2)]=r
			return r
	def makeP(self,grid) :
		print "makeP"
		return self._makeGram(grid,self.evalP)
	def _r(self,id1,id2) :
		if( not self.silent ) :
			print "_r("+str(id1)+","+str(id2)+")"
		import PiecewisePoly as poly
		u1=self._gram.func(id1).D()
		u2=self._gram.func(id2)
		return poly.Poly(u1.mult(self.x).mult(u2)).logIntegral()
	def evalR(self,id1,id2) :
		try :
			return self._R[(id1,id2)]
		except :
			r=self._r(id1,id2)
			self._R[(id1,id2)]=r
			return r
	def makeR(self,grid) :
		print "makeR"
		return self._makeGram(grid,self.evalR)
	def _q(self,id1,id2) :
		if( not self.silent ) :
			print "_q("+str(id1)+","+str(id2)+")"
		u1=self._gram.func(id1).D()
		u2=self._gram.func(id2).mult(self.x2).D()
		return u1.mult(u2).integral()
	def evalQ(self,id1,id2) :
		try :
			return self._Q[(id1,id2)]
		except :
			r=self._q(id1,id2)
			self._Q[(id1,id2)]=r
			return r
	def makeQ(self,grid) :
		print "makeQ"
		return self._makeGram(grid,self.evalQ)
