

class CommonPhi(object) :
	def __init__(self,xsi_d0_m,d0,m,d,kA) :
		import numpy as np
		import PiecewisePoly as poly
		x=np.floor(poly.pow2_(d0-d)*kA)
		if(x!=int(x)):
			raise(Exception("x is not an integer"))
		kStar=int(x)
		phi=xsi_d0_m.S(-d0).T(-m-kStar)
		self._d=d
		self._kA=kA
		self._phi=phi
	def get_(self,d0,k0) :
		import numpy as np
		import PiecewisePoly as poly
		x=np.floor(poly.pow2_(d0-self._d)*self._kA)
		if(x!=int(x)):
			raise(Exception("x is not an integer"))
		kStar=int(x)
		return self._phi.T(k0+kStar).S(d0)
	def __str__(self) :
		s="CommonPhi\n"
		s+="d="+str(self._d)+"\n"
		s+="kA="+str(self._kA)+"\n"
		return s
	def prePickle(self) :
		self._phi=ltools.polyToDescription(self._phi)
	def afterPickle(self) :
		self._phi=ltools.descriptionToPoly(self._phi)

class PhiGram(object) :
	def __init__(self,msb,phi,xsiD) :
		self._msb=msb
		self._phi=phi
		self._xsiD=xsiD
		self._map={}
	def prePickle(self) :
		self._msb=None
		self._phi=None
	def afterPickle(self,msb,phi) :
		self._msb=msb
		self._phi=phi
	def get(self,k,p) :
		try :
			return self._map[(k,p)]
		except :
			r=self._calc(k,p)
			self._map[(k,p)]=r
			return r
	def _getW(self,k) :
		(d,k)=k
		if( d=='xsi' ) :
			return self._msb.xsi(self._xsiD).get_(k)
		else :
			return self._msb.chi(d).get_(k)
	def _getPhi(self,p) :
		return self._phi.get_(d0=p[0],k0=p[1])
	def _calc(self,k,p) :
		w=self._getW(k)
		f=self._getPhi(p)
		return w.mult(f).integral()
