execfile('common.py')

import gram
import ots.io as io

name='mrMrGram.py'

version="B"
execfile('version_'+version+'.py')
basisFile='dirichlet3a_step'+str(steps)+'_d45_crN'+str(crN)+'_maxD'+str(maxD)+'_result'
gramFile='gram_version_'+version
gridFile='grid_version_'+version
mrGramFile='mrGram_version_'+version

class MeanRevertingEquation(object) :
	def __init__(self,x0,t,T,mu,meanRev,a,sigma,precision) :
		self.x0=x0
		self.t=t
		self.T=T
		self.mu=mu
		self.meanRev=meanRev
		self.a=a
		self.sigma=sigma
		self.precision=precision
		self.minimalNumberOfK=16
		self.minimalD=-7
	def calcInterval(self) :
		import scipy.stats
		import numpy
		N01Inv=scipy.stats.norm(0,1).ppf
		xsi0=abs(N01Inv(self.precision/2))
		x0=self.x0		
		mu=self.mu
		meanRev=self.meanRev
		a=self.a
		sigma=self.sigma
		dt=self.T-self.t
		muTilde=mu-0.5*sigma*sigma
		y1=a+muTilde/meanRev
		y2=numpy.log(x0)-a-muTilde/meanRev
		alpha1=y1+y2
		alpha2=y1+numpy.exp(-meanRev*dt)*y2
		beta=sigma*numpy.sqrt((1-numpy.exp(-2*meanRev*dt))/2/meanRev)
		Ym=min(alpha1,alpha2)-beta*xsi0
		Yp=max(alpha1,alpha2)+beta*xsi0
		A0=numpy.exp(Ym)
		B0=numpy.exp(Yp)
		d0=self.minimalD
		while(True) :
			kA=int(numpy.floor(poly.pow2_(d0)*A0))
			kB=int(numpy.ceil(poly.pow2_(d0)*B0))
			kk=kB-kA+1
			if( kk>=self.minimalNumberOfK ) :
				break
			d0+=1
		self.int_d0=d0
		self.int_kA=kA
		self.int_kB=kB


mr=MeanRevertingEquation(x0=x0,t=t,T=T,mu=mu,meanRev=meanRev,a=meanLevel,sigma=sigma,precision=precision)
mr.calcInterval()
		
try :
	multiBasis
except :
	multiBasis=load(basisFile)

xsi=multiBasis['xsi']
chi=multiBasis[xsi.d]
msb=gram.MultiScaleBasis(xsi,chi,mr.int_d0,mr.int_kA,mr.int_kB)
	
try :
	gm
except :
	gm=load(gramFile)	
	gm.afterPickle()

I=poly.Piece(msb.d,msb.kA,msb.kB)

def makeCall(inteval,strike) :
	strikeD=poly.pow2_(I.d())*strike
	_check(strikeD-int(strikeD)==0,"strikeD is not int")
	strikeD=int(strikeD)
	return poly.extend(poly.Piece(I.d(),strikeD,I.b()),[-strike,1])
def makePut(inteval,strike) :
	strikeD=poly.pow2_(I.d())*strike
	_check(strikeD-int(strikeD)==0,"strikeD is not int")
	strikeD=int(strikeD)
	return poly.extend(poly.Piece(I.d(),I.a(),strikeD),[strike,-1])

payoff0=makePut(I,strike)-makePut(I,strike-delta)+makeCall(I,strike)-makeCall(I,strike+delta)
shift=poly.extend(I,[-delta])
payoff=poly.LPoly(payoff0+shift)

try :
	grid
except :
	grid=load(gridFile)
	
mrGram=gram.MRGram(gram=gm,interval=poly.Piece(mr.int_d0,mr.int_kA,mr.int_kB))

P=mrGram.makeP(grid)
R=mrGram.makeR(grid)
Q=mrGram.makeQ(grid)

mrGram.beforePickle()
save(mrGram,mrGramFile)
