execfile('common.py')

import gram
import ots.io as io
import penalty as pen

name='soMix1.py'

version="B"
execfile('version_'+version+'.py')
basisFile='dirichlet3a_step'+str(steps)+'_d45_crN'+str(crN)+'_maxD'+str(maxD)+'_result'
gramFile='gram_version_'+version
gridFile='grid_version_'+version
mrGramFile='mrGram_version_'+version
phiGramFile='phiGram_version_'+version
penGramFile='penGram_version_'+version

class MeanRevertingOptimization(object) :
	def __init__(self,x0,t,T,mu,meanRev,a,sigma,precision) :
		self.x0=x0
		self.t=t
		self.T=T
		self.mu=mu
		self.meanRev=meanRev
		self.a=a
		self.sigma=sigma
		self.precision=precision
		self.minimalNumberOfK=16
		self.minimalD=-7
	def calcInterval(self) :
		import scipy.stats
		import numpy
		N01Inv=scipy.stats.norm(0,1).ppf
		xsi0=abs(N01Inv(self.precision/2))
		x0=self.x0		
		mu=self.mu
		meanRev=self.meanRev
		a=self.a
		sigma=self.sigma
		dt=self.T-self.t
		muTilde=mu-0.5*sigma*sigma
		y1=a+muTilde/meanRev
		y2=numpy.log(x0)-a-muTilde/meanRev
		alpha1=y1+y2
		alpha2=y1+numpy.exp(-meanRev*dt)*y2
		beta=sigma*numpy.sqrt((1-numpy.exp(-2*meanRev*dt))/2/meanRev)
		Ym=min(alpha1,alpha2)-beta*xsi0
		Yp=max(alpha1,alpha2)+beta*xsi0
		A0=numpy.exp(Ym)
		B0=numpy.exp(Yp)
		d0=self.minimalD
		while(True) :
			kA=int(numpy.floor(poly.pow2_(d0)*A0))
			kB=int(numpy.ceil(poly.pow2_(d0)*B0))
			kk=kB-kA+1
			if( kk>=self.minimalNumberOfK ) :
				break
			d0+=1
		self.int_d0=d0
		self.int_kA=kA
		self.int_kB=kB
	def oneTimeStepEOnly(self,tn,tnp1,Kn,gram,mrGram) :
		import numpy as np
		import scipy.linalg as la
		dt=tnp1-tn
		sigma=self.sigma
		P=_m(mrGram.makeP(Kn))
		R=_m(mrGram.makeR(Kn))
		Q=_m(mrGram.makeQ(Kn))
		G=_m(gram.gram(Kn))
		GI=G.I
		B0=(mu+meanRev*meanLevel)*P-meanRev*R-0.5*sigma*sigma*Q
		U=-GI*B0.T
		(H,D)=makeH2(dt=dt,U=U)
		I=unit(H.shape[0])
		E=(I-H)*D
		for p in range(0,11) :
			H=H*H
			E=(I+H)*E
		return (E,GI,H,U)
	def expTimeStepEOnly(self,tn,tnp1,Kn,gram,mrGram,dd) :
		dt=tnp1-tn
		steps=pow(2,dd)
		ddt=dt*1.0/steps
		(E,GI,H,U)=self.oneTimeStepEOnly(tn=tnp1-ddt,tnp1=tnp1,Kn=Kn,gram=gram,mrGram=mrGram)
		for p in range(0,dd) :
			E=E*E
		return (E,U)
	def expTimeStep(self,tn,tnp1,Kn,Knp1,gram,mrGram,cnp1,dd) :
		dt=tnp1-tn
		steps=pow(2,dd)
		ddt=dt*1.0/steps
		(E,GI,H,U)=self.oneTimeStepEOnly(tn=tnp1-ddt,tnp1=tnp1,Kn=Kn,gram=gram,mrGram=mrGram)
		for p in range(0,dd) :
			E=E*E
		Gnp1=_m(gram.gram2(Kn,Knp1))
		b=GI*Gnp1*_m(cnp1).T
		c=E*b
		return (c,E,U)
	def timeStep(self,tn,tnp1,Knp1,K0,gram,mrGram,cnp1,dd,precision) :
		#K0 is the grid of final function g. When optimizing, its components
		#should never be dropped.
		(c,_,_)=self.expTimeStep(tn=tn,tnp1=tnp1,Kn=Knp1,Knp1=Knp1,gram=gram,mrGram=mrGram,cnp1=cnp1,dd=dd)
		ids=gram.map.keys()
		X0=cnp1
		X1=[x[0,0] for x in c]
		grid0=Knp1
		N=len(grid0)
		ii=range(0,N)
		Q=[abs(X1[i]/X0[i]) for i in ii]
		Q2=[(Q[i],grid0[i]) for i in ii]
		Q2.sort(reverse=True)
		kappa=[-4,-3,-2,-1,0,1,2,3,4]
		#new grid candidates
		toAdd=[]
		for (q,(d,k)) in Q2 :
			if( q<1 ) :
				break
			toAdd+=[(d,k+i) for i in kappa if( (d,k+i) in ids )]
		#increasing scale
		(_,(dMax,kMax))=Q2[0]
		gridA=[(dMax,kMax)]
		if( type(dMax)!=type('') ) :
			gridB=[id for id in ids if id[0]==dMax+1]
			g=gram.gram2(gridA,gridB)[0]
			gg=[(abs(g[i]),gridB[i]) for i in range(0,len(g)) if g[i]!=0]
			gg.sort(reverse=True)
			for i in range(0,min(len(kappa),len(gg))) :
				toAdd.append(gg[i][1])
		#making new grid
		grid1=uniqueUnion(grid0,toAdd+K0)
		print "new grid len="+str(len(grid1))
		#making next time step
		(c1,E1,_)=self.expTimeStep(tn=tn,tnp1=tnp1,Kn=grid1,Knp1=grid0,gram=gram,mrGram=mrGram,cnp1=cnp1,dd=dd)
		#excluding components with low contribution
		L=[(abs(c1[i,0]),grid1[i]) for i in range(0,len(grid1))]
		L.sort()
		i=0
		sum=0
		while(sum<precision) :
			sum+=L[i][0]
			i+=1
		N=i-1
		grid2=[L[i][1] for i in range(N,len(L))]
		grid3=uniqueUnion(grid2,K0)
		print "corrected grid len="+str(len(grid3))
		#making time step with corrected grid
		(c2,E2,U)=self.expTimeStep(tn=tn,tnp1=tnp1,Kn=grid3,Knp1=grid0,gram=gram,mrGram=mrGram,cnp1=cnp1,dd=dd)
		return (c2,grid3,E2,U)
	def evolve(self,t,T,grid,gram,mrGram,c,dd,steps,precision) :
		dt=(T-t)*1.0/steps
		K0=grid
		for s in range(0,steps) :
			print "start step "+str(s)
			(c,grid,_,_)=self.timeStep(tn=T-(s+1)*dt,tnp1=T-s*dt,Knp1=grid,K0=K0,gram=gram,mrGram=mrGram,cnp1=c,dd=dd,precision=precision)
			c=[c[i,0] for i in range(0,len(c))]
			print "end step "+str(s)
			print "grid length " +str(len(grid))
		return (c,grid)
		
def makeCall(inteval,strike) :
	strikeD=poly.pow2_(I.d())*strike
	_check(strikeD-int(strikeD)==0,"strikeD is not int")
	strikeD=int(strikeD)
	return poly.extend(poly.Piece(I.d(),strikeD,I.b()),[-strike,1])
def makePut(inteval,strike) :
	strikeD=poly.pow2_(I.d())*strike
	_check(strikeD-int(strikeD)==0,"strikeD is not int")
	strikeD=int(strikeD)
	return poly.extend(poly.Piece(I.d(),I.a(),strikeD),[strike,-1])
def makeH2(dt,U) :
	import numpy as np
	U=dt*U
	N=U.shape[0]
	I=unit(N)
	sumUk=[]
	for k in range(0,N) :
		sum=0
		for s in range(0,N) :
			sum+=pow(U[k,s],2)
		sumUk.append(sum)
	Dk=[]
	for k in range(0,N) :
		x=(1+U[k,k])/(1+2*U[k,k]+sumUk)
		Dk.append(x)
	D=diag(Dk)
	H=D-I+D*U
	return (H,D)
class MrSolution(object) :
	def __init__(self,payoff,mu,meanRev,meanLevel,sigma,T) :
		import numpy as np
		self.g=payoff
		self.mu=mu
		self.meanRev=meanRev
		self.meanLevel=meanLevel
		self.sigma=sigma
		self.T=T
	def func(self,z) :
		import numpy as np
		g=self.g
		mu=self.mu
		meanRev=self.meanRev
		meanLevel=self.meanLevel
		sigma=self.sigma
		t=self.t
		T=self.T
		x0=self.x0
		z0=-meanRev*(T-t)
		z1=meanLevel+(mu-0.5*sigma*sigma)/meanRev
		z2=(1-np.exp(2*z0))/2/meanRev
		y1=g(np.exp(z1+np.exp(z0)*(np.log(x0)-z1)+sigma*np.sqrt(z2)*z))
		y2=np.exp(-0.5*z*z)
		return y1*y2
	def value(self,t,x) :
		import scipy as sp
		import numpy as np
		self.x0=x
		self.t=t
		spt=self.g.support()
		xA=spt.xA()
		xB=spt.xB()
		return sp.integrate.quad(self.func,-100,100)/np.sqrt(2*np.pi)

class Solver(object) :
	def __init__(self,penalty,E,G,U,cnp1,dt,epsilon,wGrid,hGrid) :
		self._penalty=penalty
		self._wGrid=wGrid
		self._hGrid=hGrid
		GI=G.I
		self._c0=cnp1
		self._epsilon=epsilon
		self._dt=dt
		self._GI=GI
		self._E=E
		self._U=U
		self._I=unit(E.shape[0])
		(Om,dOm)=self._penalty.Omega(c=cnp1,wGrid=self._wGrid,hGrid=self._hGrid)
		self._Om0=Om
		self._dOm0=dOm
		self._Es={}
	def newtonF(self,tau,c) :
		I=self._I
		(Etau,dEtau)=self.E(tau)
		epsilon=self._epsilon
		GI=self._GI
		c0=self._c0
		Om0=self._Om0
		A=Etau*GI
		(Om,dOm)=self._penalty.Omega(c=c,wGrid=self._wGrid,hGrid=self._hGrid)
		theta=tau*0.5/epsilon
		x0=-Etau*c0-theta*A*Om0
		F=c-theta*A*Om+x0
		dF=I-theta*A*dOm
		return (F,dF)
	def cauchyF(self,tau,c) :
		I=self._I
		(Etau,dEtau)=self.E(tau)
		epsilon=self._epsilon
		GI=self._GI
		c0=self._c0
		Om0=self._Om0
		A=Etau*GI
		(Om,dOm)=self._penalty.Omega(c=c,wGrid=self._wGrid,hGrid=self._hGrid)
		theta=tau*0.5/epsilon
		x1=(I-theta*A*dOm).I
		Om2=Om+Om0
		x2=dEtau*(c0+theta*GI*Om2)
		x3=0.5/epsilon*A*Om2
		F=x1*(x2+x3)
		return F
	def E(self,tau) :
		k=tau/self._dt
		kk=int(round(k))
		_check(abs(k-kk)<0.00000001,"Wrong value of tau")
		try :
			return self._Es[kk]
		except KeyError :
			E=pow(self._E,kk)
			dE=-self._U*E
			self._Es[kk]=(E,dE)
			return (E,dE)
		
		
		
try :
	gm
except :
	gm=load(gramFile)	
	gm.afterPickle()
msb=gm.msb
		
mr=MeanRevertingOptimization(x0=x0,t=t,T=T,mu=mu,meanRev=meanRev,a=meanLevel,sigma=sigma,precision=precision)
mr.calcInterval()

I=poly.Piece(msb.d,msb.kA,msb.kB)

payoff0=makePut(I,strike)-makePut(I,strike-delta)+makeCall(I,strike)-makeCall(I,strike+delta)
shift=poly.extend(I,[-delta])
payoff=poly.LPoly(payoff0+shift)

try :
	grid
except :
	grid=load(gridFile)
	
try :
	mrGram
except :
	mrGram=load(mrGramFile)
	mrGram.afterPickle(gm)
	
sol=MrSolution(payoff=payoff,mu=mu,meanRev=meanRev,meanLevel=meanLevel,sigma=sigma,T=T)
print sol.value(t,x0)

(proj,cnp1)=gm.projection2(payoff,grid)
dt=0.1
t=T-dt
(E,U)=mr.expTimeStepEOnly(tn=t,tnp1=T,Kn=grid,gram=gm,mrGram=mrGram,dd=10)

minD=1000
maxD=-1000
for id in grid :
	try :
		d=int(id[0])
		minD=min(minD,d)
		maxD=max(maxD,d)
	except :
		pass
		

epsilon=0.1
G=_m(gm.gram(grid))
cnp1_=_m(cnp1).T
	
I=unit(E.shape[0])
cPrev=cnp1_
NCauchy=10
dTau=2.0*dt
j=0

c=E*cPrev	
r=makeFunc(grid=grid,gram=gm,c=c)

hutScale=2
R=[(hutScale,k) for k in range(0,msb.kB*pow(2,hutScale-msb.d))]
penGram=load(penGramFile+'_'+str(hutScale))
penGram.afterPickle(wGram=gm)
penalty=pen.Penalty(payoff=payoff,gram=gm,penGram=penGram)
penalty.Omega(c=c,wGrid=grid,hGrid=R)

Gbar=penGram.gram(hGrid=R,wGrid=grid)
a=penalty._lastA
cnt=Gbar*(a-c)

def FindPositivePieces(data,precision) :
	r=[]
	i=0
	while(i<len(data)) :
		if( data[i]<0 or abs(data[i])<precision ) :
			i+=1
			continue
		iPos=i
		while(0<=i and data[i]>0) :
			i-=1
		iLeft=i+1
		i=iPos
		while(i<len(data) and data[i]>0) :
			i+=1
		iRight=i-1
		r.append((iLeft,iRight))
		i=iRight+1
	return r
def CorrectBoundaries(pair) :
	(x,y)=pair
	xx=x+2
	yy=y-2
	_check(xx<yy,"pair too narrow")
	return (xx,yy)
	
cnt_=[x[0,0] for x in cnt]
ppos=FindPositivePieces(data=cnt_,precision=0.001)
ppos1=[CorrectBoundaries(x) for x in ppos]

rr=makeFunc(grid=grid,gram=gm,c=G.I*Gbar.T*cnt)

class Minimizer(object) :
	"""
		To be used with scipy.optimize.fmin_slsqp
	"""
	def __init__(self,penGram,G,a,c,wGrid,hGrid) :
		self._penGram=penGram
		self._wGrid=wGrid
		self._hGrid=hGrid
		GI=G.I
		import numpy as np
		self._c=np.matrix(c)
		self._a=np.matrix(a)
		if( self._c.shape[1]!=1 ) :
			self._c=self._c.T
		if( self._a.shape[1]!=1 ) :
			self._a=self._a.T
		self._GI=GI
	def makeM0(self) :
		try :
			return self._M0
		except :
			pass
		A1=self.makeA1()
		Atilde=self.makeAtilde()
		M0=-A1*Atilde
		self._M0=M0
		return M0
	def makeGbar(self) :
		try :
			return self._Gbar
		except :
			pass
		Gbar=self._penGram.gram(hGrid=self._hGrid,wGrid=self._wGrid)
		self._Gbar=Gbar
		return Gbar
	def Omega(self,lam) :
		import numpy as np
		L=[x for x in lam]
		Lam=np.diag(L)
		GI=self._GI
		Gbar=self.makeGbar()
		a=self._a
		c=self._c
		z=GI*Gbar.T*Lam*Gbar*(a-c)
		return z
	def makeB0(self) :
		try :
			return self._B0
		except :
			pass
		a=self._a
		c=self._c
		A1=self.makeA1()
		b0=A1*(a-c)
		self._B0=b0
		return b0
	def makeB1(self) :
		try :
			return self._B1
		except :
			pass
		n=len(self._hGrid)
		Gbar=self.makeGbar()
		a=self._a
		c=self._c
		r=Gbar*(a-c)
		import numpy as np
		z=np.ndarray(shape=2*n)
		z[:n]=0
		rr=np.array(r).reshape(n)
		z[n:2*n]=rr
		self._B1=np.matrix(z).T
		return self._B1
	def makeA1(self) :
		try :
			return self._A1
		except :
			pass
		Gbar=self.makeGbar()
		A1=self._GI*Gbar.T*Gbar
		self._A1=A1
		return A1
	def makeAtilde(self) :
		try :
			return self._Atilde
		except :
			pass
		h=self._GI
		c=self._c
		a=self._a
		g=self.makeGbar()
		R=[]
		for i in range(0,h.shape[0]) :
			RR=[]
			R.append(RR)
			for r in range(0,g.shape[0]) :
				sum=0
				for p  in range(0,h.shape[1]) :
					for j in range(0,g.shape[1]) :
						sum+=h[i,p]*g[r,p]*g[r,j]*(a[j,0]-c[j,0])
				RR.append(sum)
		import numpy as np
		Atilde=np.matrix(R)
		self._Atilde=Atilde
		return Atilde
	def objectiveFunc(self,lam) :
		import numpy as np
		x=np.matrix(lam)
		if( x.shape[1]!=1 ) :
			x=x.T
		M0=self.makeM0()
		b0=self.makeB0()
		y=M0*x+b0
		n=y.T*y
		_check(n.shape==(1,1),"Wrong shape")
		return n[0,0]
	def greaterThanConstr(self,lam) :
		M1=self.makeM1()
		b1=self.makeB1()
		import numpy as np
		x=np.matrix(lam)
		if( x.shape[1]!=1 ) :
			x=x.T
		x=M1*x+b1
		return np.array(x).reshape(len(x))
	def makeM1(self) :
		try :
			return self._M1
		except :
			pass
		n=len(self._hGrid)
		import numpy as np
		z=np.ndarray(shape=(2*n,n))
		z[0:n,0:n]=unit(n)
		a=-self.makeGbar()*self.makeAtilde()
		z[n:2*n,0:n]=a
		import numpy as np
		z=np.matrix(z)
		self._M1=z
		return z
	def gradientOfObjectiveFunc(self,lam) :
		import numpy as np
		x=np.matrix(lam)
		if( x.shape[1]!=1 ) :
			x=x.T
		M0=self.makeM0()
		b0=self.makeB0()
		x1=M0*x+b0
		n=len(lam)
		z=np.ndarray(shape=n)
		for m in range(0,n) :
			x2=M0[:,m]
			y=x1.T*x2
			z[m]=y[0,0]
		return 2*z
	def gradientsOfGTC(self,lam) :
		return self.makeM1()

def numericalGradient(func,x,h) :
	r=[]
	x0=x
	for i in range(0,len(x0)) :
		x1=[]
		for j in range(0,len(x0)) :
			if( i==j ) :
				x1.append(x0[j]+h)
			else :
				x1.append(x0[j])
		f0=func(x0)
		f1=func(np.array(x1))
		r.append((f1-f0)/h)
	return r
def numericalGradient2(func,x,h) :
	r=[]
	x0=x
	for i in range(0,len(x0)) :
		x1=[]
		for j in range(0,len(x0)) :
			if( i==j ) :
				x1.append(x0[j]+h)
			else :
				x1.append(x0[j])
		f0=func(x0)
		f1=func(np.array(x1))
		rr=[]
		r.append(rr)
		for i in range(0,len(f0)) :
			rr.append((f1[i]-f0[i])/h)
	return r

minimizer=Minimizer(penGram=penGram,G=G,a=a,c=c,wGrid=grid,hGrid=R[ppos1[0][0]:ppos1[0][1]+1])
x0=np.array([0.0001 for x in range(0,len(minimizer._hGrid))])

import scipy as sp
minRes=sp.optimize.fmin_slsqp(
	func=minimizer.objectiveFunc,
	x0=x0,
	f_ieqcons=minimizer.greaterThanConstr,
	fprime=minimizer.gradientOfObjectiveFunc,
	fprime_ieqcons=minimizer.gradientsOfGTC,
	acc=1e-10
	)
	
om=minimizer.Omega(minRes)
omF=makeFunc(grid=grid,gram=gm,c=om)
cF=makeFunc(grid=grid,gram=gm,c=c)
aF=makeFunc(grid=grid,gram=gm,c=a)
pp(aF-cF-omF)
