import PiecewisePoly as poly

st1=poly.Set(poly.Piece(0,0,3))
st2=poly.Set(poly.Piece(0,3,6))
st3=poly.Set(poly.Piece(0,0,1))
st4=poly.Set(poly.Piece(0,1,2))
st5=poly.Set(poly.Piece(0,0,4))
st6=poly.Set(poly.Piece(0,5,6))
st7=poly.Set(poly.Piece(0,2,6))

#case 1,2
u1=poly.union(st1,st2)
assert u1.scale()==0 and u1.pieces()==[(0,6)]
u5=poly.union(st1,st6)
assert u5.scale()==0 and u5.pieces()==st1.pieces()+st6.pieces()
#case 3,4
u6=poly.union(st1,st7)
assert u6.scale()==0 and u6.pieces()==[(0,6)]
#case  5,6
u3=poly.union(st1,st4)
assert u3.scale()==0 and u3.pieces()==st1.pieces()
u2=poly.union(st1,st3)
assert u2.scale()==0 and u2.pieces()==st1.pieces()
u4=poly.union(st1,st5)
assert u4.scale()==0 and u4.pieces()==[(0,4)]

#case 1,2
i1=poly.intersect(st1,st2)
assert i1.pieces()==[]
#case 5,6
i2=poly.intersect(st1,st3)
assert i2.scale()==0 and i2.pieces()==st3.pieces()
#case 3,4
i6=poly.intersect(st1,st7)
assert i6.scale()==0 and i6.pieces()==[(2,3)]
#multiple
i3=poly.intersect(u5,st1)
assert i3.scale()==0 and i3.pieces()==st1.pieces()
i4=poly.intersect(u5,st6)
assert i4.scale()==0 and i4.pieces()==st6.pieces()

#case 1,2
s1=poly.subtract(st1,st2)
assert s1.scale()==0 and s1.pieces()==st1.pieces()
s5=poly.subtract(st1,st6)
assert s5.scale()==0 and s5.pieces()==st1.pieces()
#case 3,4
s6=poly.subtract(st1,st7)
assert s6.scale()==0 and s6.pieces()==[(0,2)]
#case  5,6
s3=poly.subtract(st1,st4)
assert s3.scale()==0 and s3.pieces()==[(0,1),(2,3)]
s2=poly.subtract(st1,st3)
assert s2.scale()==0 and s2.pieces()==[(1,3)]
s4=poly.subtract(st1,st5)
assert s4.scale()==0 and s4.pieces()==[]

#case 1,2
assert st1.isIncludedIn(st2)==False
assert st1.isIncludedIn(st6)==False
#case 3,4
assert st1.isIncludedIn(st7)==False
#case  5,6
assert st1.isIncludedIn(st4)==False
assert st4.isIncludedIn(st1)==True
assert st1.isIncludedIn(st3)==False
assert st3.isIncludedIn(st1)==True
assert st1.isIncludedIn(st5)==True
assert st5.isIncludedIn(st1)==False

#case 1,2
u1=poly.union(st1.upscale(1),st2)
assert u1.scale()==1 and u1.pieces()==[(0,12)]
u5=poly.union(st1.upscale(1),st6)
assert u5.scale()==1 and u5.pieces()==st1.upscale(1).pieces()+st6.upscale(1).pieces()
#case 3,4
u6=poly.union(st1.upscale(1),st7)
assert u6.scale()==1 and u6.pieces()==[(0,12)]
#case  5,6
u3=poly.union(st1.upscale(1),st4)
assert u3.scale()==1 and u3.pieces()==st1.upscale(1).pieces()
u2=poly.union(st1.upscale(1),st3.upscale(1))
assert u2.scale()==1 and u2.pieces()==st1.upscale(1).pieces()
u4=poly.union(st1.upscale(1),st5)
assert u4.scale()==1 and u4.pieces()==[(0,8)]

#case 1,2
assert st1.upscale(1).isIncludedIn(st2)==False
assert st1.upscale(1).isIncludedIn(st6)==False
#case 3,4
assert st1.upscale(1).isIncludedIn(st7)==False
#case  5,6
assert st1.upscale(1).isIncludedIn(st4)==False
assert st4.upscale(1).isIncludedIn(st1)==True
assert st1.upscale(1).isIncludedIn(st3)==False
assert st3.upscale(1).isIncludedIn(st1)==True
assert st1.upscale(1).isIncludedIn(st5)==True
assert st5.upscale(1).isIncludedIn(st1)==False

